      SUBROUTINE AFWKL(MAP,WORK,ATPR,ITPR,NAME,NAT,NC,R2,R,NX,NY,NZ,
     1 CEL,IN,DS,FT,NFAT,JFAT,NSIZE,NPRS,BOV,ITLE)
C***********************************************************************
C
C     AUTOFOUR, Version Autumn 1997
C
C     Authors: A.J. Kinneging and R.A.G. De Graaff (1984)
C              Improved further by R. de Gelder and R.A.G. de Graaff
C              (1990 onwards)
C              X-ray Department Gorlaeus Laboratories
C              PO Box 9502, 2300 RA Leiden
C              The Netherlands
C              E-mail: graaff_r@rulgca.leidenuniv.nl
C
C     Last edit: November 1997
C
C***********************************************************************
C
C      Changes compared to IBM-version January 1988:
C
C     -Manipulation of scattering factors changed
C     -NAG-routines replaced by NETLIB-routines (double precision)
C     -Atoms are sorted on R-value at the start of the program
C     -Reads default 0.2*Nat peaks from input (if possible)
C     -This number can be changed in card 3, column 46-50
C     -Grid is adapted in subroutine grid (0.2 angstrom)
C     -Final R and R2 are written to least squares file
C     -If structure is solved the number "1" is written to unit 10
C     -Early check of actual R2 versus estimated R2: variable Echk
C     -Echk*100 is read from card 3, column 51-55
C     -If early check stops the program the number "2" is written to uni
C     -80 columns, nicer output
C     -Reads old and new (post October 1994) structurefactor files
C     -Atomlist is clustered
C     -Produces ATOMS-file suitable for Xtal and Shellx
C     -On succesful convergence a PDB-file is written
C     -Atomtype free format input may be used
C     -Other input may be interspersed with comment
C     -In the case of Crunch-failure coordinates are put in a format
C     -suitable for Deter
C     -Peak selection much improved in October, November 1997
C
C***********************************************************************
      INTEGER MAP(NSIZE)
C
C  PREPARE FINAL PRINT
C  PREPARE SEARCH80 INPUT
C  PUT OUT LEAST SQUARES INPUT MODEL
C  PUT OUT ATOM-FILE AND PDB FILE
C
      DIMENSION IN(NX),DS(NAT),Oinv(3,3),WORK(NSIZE)
      DIMENSION ATPR(6,NAT),ITPR(2,NAT),PRM(6),CEL(6),FT(32,NFAT)
      CHARACTER NAME(NAT)*8, ITLE(20)*4
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(10),
     1 ISER(10),SF,SQ,DN,XN,DX,DY,DZ,DM,XM
      COMMON/PNTR/IPNT(10),JPNT(10),S(10),KPNT(10),NMO(10),KV(10)
     1 ,LPNT(10),EXCL(10)
C     Pir=3.14159265/180.0
      IF(NC.LT.0)GOTO 200
C
C  Make one or fragments out of the model
C
      BGR=1.0
      CALL FRAG(ATPR,IN,DS,NPRS,CEL)
      WRITE(LO,1)NC,R,R2,CEL,NPRS
1     FORMAT(/,' ','Convergence Obtained',5X,'Cycle: ',I5,
     1 /' ','Final R: ',F6.4,'  Final R2: ',F6.4,
     3 /' ','Cell Constants: ',3F10.4,3F10.2,
     4 /' ','Number of atoms found: ',I5)
C
C  PRINT LIST OF ATOMIC COORDINATES
C
      WRITE(LO,4)
4     FORMAT(/,' AFWKL: Parameter-list'///' ',8X,'Height',4X,'Atom',
     1 6X,'X',7X,'Y',7X,'Z',6X,'Cluster',/)
2     FORMAT(' ',I4,3X,I6,5X,A6,3(2X,F6.4),5X,I3)
5     FORMAT(A8,6X,5F10.4)
C
C     LFILE IS USED FOR OUTPUT OF INTERMEDIATE AND FINAL RESULTS,
C     TO BE DISPLAYED BY PLUTON
C
      CLOSE(LFILE)
      OPEN(LFILE,FORM='FORMATTED',STATUS='UNKNOWN')
      WRITE(LFILE,'(A)') 'TITLE FINAL RESULTS'
C
C     OUTPUT SYMMETRY INFORMATION:
C
      CALL PRIXYZ(CEL)
      Write(LPDB,111)(Cel(i),i=1,6)
  111 Format('CRYST1',3f9.3,3f7.2)
      fj=0.0
      Call matinv(ort,oinv)
      Do 112 I=1,3
      WRITE(LPDB,121)i,(oinv(i,j),j=1,3),fj
112   Continue
121   Format('SCALE',I1,4x,3f10.6,5x,f10.6)
      DO 100 I=1,NPRS
      DO  10 II=1,5
   10 PRM(II)=ATPR(II,I)
      TFAT=ITPR(1,I)
      WRITE(LO,2)I,ITPR(2,I),NAME(I),(PRM(II),II=1,3),IN(I)
      WRITE(LSQ,5)NAME(I),TFAT,(PRM(II),II=1,4)
      WRITE(LFILE,'(''ATOM '',A6,3F10.4)') NAME(I),(PRM(II),II=1,3)
      Write(LN,124)Name(I),(prm(ii),ii=1,3)
      DO 20 II=1,3
      XO=0.0
      DO 21 K=1,3
21    XO=XO+PRM(K)*ORT(II,K)
20    PRM(II+3)=XO
      WRITE(LPDB,125)I,NAME(I)(1:6),(PRM(II),II=4,6),BGR,BOV,
     * INT(ATPR(5,I))
124   Format('ATOM',6x,A8,2x,3f10.4)
125   FORMAT('ATOM',2x,I5,1x,A6,12x,3F8.3,2F6.2,I4)
  100 CONTINUE
C
C  CLOSE LFILE, LN TO MAKE INFORMATION IMMEDIATELY
C  AVAILABLE FOR ANALYSIS
C
      CLOSE(LFILE)
      CLOSE(LN)
      CLOSE(LPDB)
C
C  WRITE R AND R2 TO LEAST SQUARES FILE
C
      WRITE(LSQ,123)NC,R,R2,CEL,NAT
  123 FORMAT('CONVERGENCE OBTAINED',5X,'CYCLE :',I5,
     1 /'FINAL R :',F6.4,'  FINAL R2 :',F6.4,
     3 /'CELL CONSTANTS :',3F10.4,3F10.2,
     4 /'NUMBER OF ATOMS FOUND :',I5)
      IF(R2.GT.STOPR)WRITE(LO,7)
7     FORMAT(/,' AFWKL: Final R2 higher than expected'
     2 ,/' If the difference is large the parameters written on disk'
     3 ,' may contain serious errors'
     4 ,/' check spacegroup and be prepared for disorder')
      GOTO 300
  200 WRITE(LO,8)
    8 FORMAT(/,' AFWKL: No convergence was reached',/
     1  '        Outputfile for SEARCH is prepared',/
     2  '        On unit 11 a file is written which contains'/
     3  '        coordinates suitable for input to Deter')
C     NPC=NAT
C     Call search(map,work,nx,ny,nz,nrx,atpr,itpr,in,nat,nprs,
C    1 npc,ft,nfat,jfat,ifail,R2)
      Do 201 i=1,NPRS
      IFAT=ITPR(1,I)
      IF(I.EQ.1)IFATO=IFAT
C     IFAT=KPNT(IPNT(ITPR(1,I)))
C     IFAT=KPNT(IPNT(JFAT))
C     IF(IFAT.LT.1.OR.IFAT.GT.10)IFAT=IFATO
C     IFATO=IFAT
      IF(IFAT.NE.IFATO)GOTO 251 
      Write(LN,203)FT(1,IFAT),(atpr(ii,i),ii=1,3)
201   Continue
202   Format('ATOM',6x,i5,5x,3f10.4)
203   Format(F4.1,3x,3f10.4)
251   Close(LN)
  300 CONTINUE
      NUL=0
      REWIND LSCRA
      WRITE(LSCRA)ITLE,NUL,CEL,NSYM,MCENTR,LATT,NAT,TS,IS
      WRITE(LSCRA)NX,NZ,NY
      INDEX=0
      DO 22 I=1,NY
      DO 22 J=1,NZ
      DO 23 K=1,NX
      INDEX=INDEX+1
      IN(K)=MAP(INDEX)
23    CONTINUE
      WRITE(LSCRA)IN
22    CONTINUE
      WRITE(LO,6)
    6 FORMAT(/,
     1 ' AFWKL: Parameters prepared for least squares refinement')
      RETURN
      END
