      SUBROUTINE BKGEN(TOPO,IBKDIM,REF,STREX,W,NREF,NSTR,NSTREX,HAS,
     1 IP,ICRI,ICRA,ICRB,ISTART,NN,MIR,NOTF)
C  *******************************************************************
C  Program:  deter (.f,.for,.fortran)
C  Version:  Summer 1998
C  Language: FORTRAN77
C  Purpose:  solving the phase problem in single-crystal x-ray
C            diffraction
C  *******************************************************************
C
C  For information, comments, suggestions, complaints, please contact:
C
C  RAG de Graaff
C  Leiden Institute of Chemistry
C  Gorlaeus Laboratories
C  University of Leiden
C  PO Box 9502
C 2300 RA Leiden, The Netherlands
C
C  E-mail: rag@chemb0b.leidenuniv.nl
C  Tel:    +31 +71 5274414
C
C  *******************************************************************
C Extensive revision Rag May, June '95: Reads formatted structure factor
C       file 25, file may contain phases and weights. Phases may be
C       refined or not. Downwards compatible. Results may differ from
C       earlier versions as reflections used to construct top row are
C       now taken from files 15 or 25, not 9 anymore. NSTR reflections
C       - input - are used here. Threshold Emin=1.2 now in LESTR.
C  Last Revision: RAG Summer 1998
C  Uses largest eigenvalue in phase refinement. However, the old
C  refinement is supported still. Construction of matrices > N
C  Phase refinement based on minimizing negative eigenvalues
C  See: van der Plas et al, Acta Cryst A, 1998
C  Lots of dead code removed
C
C***********************************************************************
C  ADDPI: ADD PI TO PHASES IN LOWER LARGE TRIANGLE OF INPUT MATRIX
C***********************************************************************
C  LAST EDIT: 27-09-90
C***********************************************************************
      INTEGER REF(NN,NREF),STREX(NSTREX),HAS(2,1),W(2,NSTR),
     1 HKL(2,2),ILOC(2,2)
      DIMENSION TOPO(IBKDIM,IBKDIM)
      WRITE(IP,*)'    '
      WRITE(IP,*)'FILL QUALITY MATRIX'
      WRITE(IP,*)'    '
      WRITE(IP,300)ICRA,ICRI,ICRB
  300 FORMAT(' CRITERION USED: ||E -',I2,'|**',I1,' -',I2,'|')
C
C  DETERMINE HKL OF REFLEXION GENERATED BY TWO TOPROW ELEMENTS
C  AND USE PROPERTIES OF THIS REFLEXION WHICH ARE IN REF()
C  USE |E|-VALUES IN REF(1,*)
C
      M128=8421504
	NUL=1
      IF(NOTF.GT.0)THEN
      VALUE=100*NOTF
      ELSE
      VALUE=NUL
      ENDIF
      TOPO(1,1)=NUL
      DO 100 I=2,IBKDIM
      TOPO(I,I)=NUL
      DO 200 J=1,I-1
      HKL(2,1)=STREX(J)-STREX(I)+M128
      HKL(2,2)=STREX(I)-STREX(J)+M128
C
C  DETERMINE LOCATION IN REF()
C
      CALL FINHAS(HAS,HKL,2,ILOC,ITEL,0)
C
C  CHECK IF REFLEXION EXISTS (ILOC=0: REFLEXION NOT PRESENT)
C
      IF(MIR.NE.1)THEN
C
C  NORMAL AB INITIO DETER RUN
C
      IF (ILOC(2,1).NE.0)THEN
C
C  TAKE AS QUALITY MATRIX ELEMENT THE VALUE CALCULATED FROM THE
C  CRITERION CONSTRUCTED FROM |E|, ICRI, ICRA AND ICRB
C
C  SCALEFACTOR USED AVOIDS ERRORS CAUSED BY MACHINE PRECISION
C
      TOPO(I,J)=ABS((ABS(REF(1,ILOC(2,1))/1000.0-ICRA)**ICRI)-ICRB)
     1  *100
      TOPO(J,I)=TOPO(I,J)
      ELSE
C
C  NOT OBSERVED REFLEXIONS GET VALUE NUL
C
      CALL RSTRC(HKL(2,1),MK)
      IF(MK.NE.0)THEN
      TOPO(I,J)=NUL
      ELSE
      TOPO(I,J)=VALUE
      ENDIF
      TOPO(J,I)=TOPO(I,J)
      ENDIF
      ELSE
C
C  DIFFERENT OPIMISATION USING WEIGHTS OF INPUT PHASES
C
      IF(ILOC(2,1).NE.0)THEN
C
C  TAKE AS QUALITY MATRIX ELEMENT THE VALUE OF THE WEIGHT
C
      TOPO(I,J)=REF(8,ILOC(2,1))*100.0
      TOPO(J,I)=TOPO(I,J)
      ELSE
      TOPO(I,J)=NUL
      TOPO(J,I)=NUL
      ENDIF
      ENDIF
      IF(TOPO(I,J).LT.0.001) THEN
      TOPO(I,J)=NUL
      TOPO(J,I)=NUL
      ENDIF
  200 CONTINUE
  100 CONTINUE
      RETURN
      END
