      SUBROUTINE CELL(P,Q,V,IOPT)
C
C  CALCULATE RECIPROCAL LATTICE CONSTANTS FROM CELL PARAMETERS (IOPT=0)
C  CALCULATE CONSTANTS Q, 1/D**2=H*H*Q1+K*H*Q2 ETC (IOPT#0)
C
C  P AND Q MAY HAVE THE SAME PHYSICAL ADRESS
C
      DIMENSION P(6),Q(6)
      PIR=4.0*ATAN(1.0)/180.0
      CA=COS(PIR*P(4))
      CB=COS(PIR*P(5))
      CC=COS(PIR*P(6))
      SA=SIN(PIR*P(4))
      SB=SIN(PIR*P(5))
      SC=SIN(PIR*P(6))
      V=P(1)*P(2)*P(3)
     1 *SQRT(1.0-CA*CA-CB*CB-CC*CC+2.0*CA*CB*CC)
      AS=P(2)*P(3)*SA/V
      BS=P(1)*P(3)*SB/V
      CS=P(1)*P(2)*SC/V
      CAS=(CB*CC-CA)/(SB*SC)
      CBS=(CC*CA-CB)/(SC*SA)
      CCS=(CA*CB-CC)/(SA*SB)
      IF(IOPT.NE.0) GOTO 10
      Q(1)=AS
      Q(2)=BS
      Q(3)=CS
      Q(4)=ACOS(CAS)/PIR
      Q(5)=ACOS(CBS)/PIR
      Q(6)=ACOS(CCS)/PIR
      GOTO 9999
   10 CONTINUE
      Q(1)=AS**2
      Q(2)=BS**2
      Q(3)=CS**2
      Q(4)=2.0*AS*BS*CCS
      Q(5)=2.0*BS*CS*CAS
      Q(6)=2.0*CS*AS*CBS
 9999 RETURN
      END
