      SUBROUTINE MMTRX(A,NM,NNRM,EMX,PMX,GEW,
     1 IJP,NIJP,IJQ,NIJQ,REF,NN,NREF,HAS,W,W1,KHL,NK,ITAPE,STR,
     2 NSTR,NSTT,W3,IP,LOP,EGEM,EGEMT)
C
C  PARAMETERS:
C
C  A(NM,NNRM) = INPUT =
C  ARRAY CONTAINING H, K, L + 128 OF TOP ROW IN BYTES 2, 3, 4 IN A(*,I)
C
C  NM = INPUT = THE ORDER OF ANY MATRIX AS WELL
C  AS THE FIRST DIMENSION OF A
C
C  EMX(NM,NM,NNRM) = OUTPUT =
C  MATRIX OF E-VALUES. NOT OBSERVED REFLEXIONS ARE ZERO
C
C  PMX(NM,NM,NNRM) = OUTPUT
C  PHASES ARE SET TO 1010MC
C  APPROPRIATE SHIFTS AND SIGNS ARE APPLIED
C
C  GEW(NM,NM,NNRM) = OUTPUT
C  RELIABILTY OF PHASES READ IN LEREF
C
C  IJP = OUTPUT =
C  ARRAY CONTAINING: ROW (IRY), COLUMN (IKO) AND MATRIX NUMBER OF THE
C  INDEPENDENT VARIABLES (IMA). IRY > IKO ALWAYS
C  INFORMATION ON THE SYMMETRY DEPENDENTS (IBE AND IEI)
C  PHASE RESTRICTION (MK) AND REFLEXION TYPE (ITY)
C
C  THE ARRAY IJP(I,*) IS CONFIGURATED AS FOLLOWS
C
C  I=1  IRY
C  I=2  IKO
C  I=3  IMA
C  I=4  IBE
C  I=5  IEI
C  I=6  MK
C  I=7  ITY
C
C  IBE: BEGIN OF RELATIONS OF THIS REFLEXION IN IJQ
C  IEI: LAST OF THE DEPENDENTS OF THIS REFLEXION
C  IEI=0: NO RELATIONS
C  MK: THE PHASE IS RESTRICTED TO 15*(MK-1) (+PI) UNLESS MK=1
C  ITY=1: KNOWN REFLEXION  ITY=2: SYMBOL
C  ITY=3: REFLEXION WILL NOT BE REFINED
C
C  NIJP = OUTPUT = DIMENSION OF IJP
C
C  IJQ  = OUTPUT =
C  ARRAY CONTAINING INFORMATION DESCRIBING THE RELATIONS
C  PMX(I1,J1,M1)=PMX(I2,J2,M2)*(1-2*IT)+IS*PI/12
C
C  THE FORMAT OF IJQ(I,*) IS:
C
C  I=1  I1
C  I=2  J1
C  I=3  M1
C  I=4  I2
C  I=5  J2
C  I=6  M2
C  I=7  IS
C  I=8  IT
C  I1, J1, M1 ARE THE MATRIX COORDINATES OF THE DEPENDENT
C  I2, J2, M2 ARE THE COORDINATES OF THE PARENT REFLEXION
C  IS AND IT DEFINE THE PHASE RELATION
C  NOTE: NOT OBSERVED ARE NOT STORED IN IJP AND IJQ
C
C  NIJQ = OUTPUT = DIMENSION OF IJQ
C
C  REF = INPUT = PARENT REFLEXION LIST
C
C  NN,NREF = INPUT = DIMENSIONS OF REF
C
C  HAS = INPUT = HASHTABLE
C
C  W(NM), W1(NM*(NM-1)/2) AND KHL(6,NSYM) ARE SCRATCH ARRAYS
C
C  ITAPE = INPUT = SCRATCH TAPE
C
      INTEGER HMAX
      INTEGER IE,EIJP(4),EIJQ(4)
      INTEGER REF(NN,NREF),HAS(2,1),W(2,NM),STR(NSTR),
     1 W3(2,NSTR),W1,A
C     CHARACTER*8 IJ,KL
      DIMENSION A(NM,NNRM),EMX(NM,NM,NNRM),PMX(NM,NM,NNRM),
     1 IJP(7,NIJP),IJQ(8,NIJQ),W1(1),KHL(6,NK)
      DIMENSION GEW(NM,NM,NNRM)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
      COMMON /DETPAR/ E000,EONOB1,EONOB2,NDIM1,NDIM2
      M128=8421504
      PI=3.14159265
      PIR=PI/180.0
      NSTT=0
C
C  ZERO WEIGHTMATRIX AND PHASES ARE SET TO UNKNOWN
C
C  FIND LOCATIONS OF STR IN REF
C
      DO 1317 I=1,NSTR
 1317 W3(2,I)=STR(I)
      CALL FINHAS(HAS,W3,NSTR,W3,ITEL,0)
      DO 1318 I=1,NM
      DO 1318 J=1,NM
      DO 1318 L=1,NNRM
      IF(NN.EQ.6)PMX(I,J,L)=1010.0
1318  GEW(I,J,L)=0.0
C
C  CLEAR W3(1,*) FOR NUMBER OF TIMES A STRONG REFLECTION
C  APPEARS IN THE MATRIX
C
      DO 109 IR=1,NSTR
      W3(1,IR)=0
  109 CONTINUE
C
C  LOCATE IDENTITY OPERATION
C
      IEEN=0
      DO 5 I=1,NSYM
      DO 3 J=1,3
      IF(IS(1,J,I).NE.J) GOTO 5
      IF(IS(2,J,I).NE.0) GOTO 5
      IF(ABS(TS(J,I)).GT.0.001) GOTO 5
    3 CONTINUE
      IEEN=I
      GOTO 6
    5 CONTINUE
    6 IF(IEEN.NE.0) GOTO 7
      WRITE(LO,1)
    1 FORMAT(' MMTRX :  NO IDENTITY OPERATION')
      STOP
    7 CONTINUE
      CCED=1.0/CED
C
C  INITIALIZE EMX 
C
C  LOOP OVER THE MATRICES
C
      EGEMT=0.0
      DO 105 INM=1,NNRM
C
C  WRITE DATA BASE OUTPUT
C
      WRITE(LOP,876)INM,NM
  876 FORMAT(' ORDER MATRIX',I5,':',I10)
C
C  LOOP OVER THE ROWS
C
      EGEM=0.0
      DO 100 I=2,NM
      JMAX=I-1
C
C  PUT ROW I IN W
C
      DO 10 J=1,JMAX
   10 W(2,J)=A(J,INM)-A(I,INM)+M128
C
C  LOCATE REFLEXIONS IN REF
C
      CALL FINHAS(HAS,W,JMAX,W,ITEL,1)
C
C  INITIALIZE ROW I IN EMX AND PMX
C
      DO 30 J=1,JMAX
      ILOC=W(2,J)
C
C  REFLEXION NOT OBSERVED
C
      PMX(I,J,INM)=0.0
      IF(ILOC.EQ.0) GOTO 20
C
C  DECODE E-VALUE
C
      EMX(I,J,INM)=CCED*REF(1,ILOC)
      EGEM=EGEM+EMX(I,J,INM)
C
C  PUT IN UNKNOWN PHASE IF NORMAL RUN
C  PUT IN PHASE IF PHASES ARE AVAILABLE IN REF
C
C     IF(NN.EQ.6)THEN
C     PMX(I,J,INM)=1010.0
C     ENDIF
      GOTO 30
   20 CONTINUE
      EMX(I,J,INM)=EONOB1
   30 CONTINUE
  100 CONTINUE
      EGEM=EGEM/((NM**2-NM)/2)
      EGEMT=EGEMT+EGEM
C     WRITE(IP,104)INM,EGEM
C
C  WRITE MATRIX INFORMATION TO SHORT OUTPUT FILE
C
C     BVH(1)=M128
C     DO 123 IR=2,N
C     BVH(IR)=A(IR,INM)
C 123 CONTINUE
      WRITE(LOP,874) EGEM
      WRITE(LOP,*)'PACKED TOPROW:'
      WRITE(LOP,875) M128,(A(IR,INM),IR=1,NM)
  104 FORMAT(' AVERAGE E-VALUE OF (SUB)MATRIX ',I5,'= ',F8.3)
  874 FORMAT(' AVERAGE E-VALUE:',F10.5)
  875 FORMAT(5(5I10,/),5I10)
  105 CONTINUE
C
C  DUMP REF ON ITAPE
C
      REWIND ITAPE
      CALL DUMP(REF,NN*NREF,ITAPE)
C
C  INITIALIZE IJP AND IJQ
C
      NIJP=0
      NIJQ=0
      NIET=0
C
C  CLEAR REF, EXCEPT REFLEXION TYPE, PHASE SHIFT, PHASE AND WEIGHT
C  PUT TYPE IN BYTE 6
C
      DO 110 I=1,NREF
      REF(6,I)=REF(4,I)
      DO 110 J=1,5
  110 REF(J,I)=0
C
C  LOOP OVER THE MATRICES
C
      DO 205 INM=1,NNRM
C
C  LOOP OVER THE ROWS
C
      DO 200 I=2,NM
      JMAX=I-1
C
C  DETERMINE ROW J
C
      DO 120 J=1,JMAX
      MN=M128+A(J,INM)-A(I,INM)
  120 W(2,J)=MN
      CALL FINHAS(HAS,W,JMAX,W1,ITEL,1)
      DO 140 J=1,JMAX
C
C  GET LOCATION IN REF
C
      J2=2*J
      ILOC=W1(J2)
C
C  LOOK FOR STRONG REFLEXIONS AND COUNT APPEARANCE OF REFLEXIONS
C
      DO 111 IR=1,NSTR
      ISLOC=W3(2,IR)
      IF(ISLOC.EQ.ILOC) THEN
      NSTT=NSTT+1
      W3(1,IR)=W3(1,IR)+1
      END IF
  111 CONTINUE
C
C  CALCULATE PHASE RESTRICTION
C
      CALL RSTRC(W(2,J),MK)
C
C
C  MK=0: FORBIDDEN REFLEXION, SET E=0 AND DO NOT STORE
C
      IF(MK.NE.0) GOTO 122
      EMX(I,J,INM)=0.0
  122 CONTINUE
      IF(ILOC.NE.0) GOTO 125
C
C  REFLEXION NOT FOUND, PROCEED WITH NEXT ELEMENT
C
      GOTO 140
C
C  REFLEXION FOUND
C
  125 CONTINUE
C
C  GET ROW AND COLUMN NUMBER
C  GET SIGN AND PHASESHIFT
C  IF KM=0 THEN A NEW INDEPENDENT REFLEXION IS FOUND
C
      KM=REF(3,ILOC)
      JUNP=W1(J2-1)
      ITW=JUNP/64
      ISW=JUNP-64*ITW
      IF(KM.EQ.0)GOTO 130
C
C  SYMMETRY DEPENDENT IS FOUND
C  CALCULATE PHASE SHIFT WITH RESPECT TO PARENT
C
      ITR=REF(1,ILOC)
      ISR=REF(2,ILOC)
C
C  GET SIGN
C
      IT=(1-2*ITR)*(1-2*ITW)
      ISS=ISW-IT*ISR
      ISS=MOD(ISS,24)
      IF(ISS.LT.0) ISS=ISS+24
      IF(ISS.EQ.0) ISS=+0
      I2=REF(3,ILOC)
      J2=REF(4,ILOC)
      M2=REF(5,ILOC)
      IF(NN.EQ.8)THEN
      PMX(I,J,INM)=PMX(I2,J2,M2)*IT+ISS*PI/12
      GEW(I,J,INM)=GEW(I2,M2,M2)
      ENDIF
      IT=(1-IT)/2
      NIJQ=NIJQ+1
C
C  PUT SPECIFICATION OF RELATION IN IJQ
C
      IJQ(1,NIJQ)=I
      IJQ(2,NIJQ)=J
      IJQ(3,NIJQ)=INM
      IJQ(4,NIJQ)=I2
      IJQ(5,NIJQ)=J2
      IJQ(6,NIJQ)=M2
      IJQ(7,NIJQ)=ISS
      IJQ(8,NIJQ)=IT
      GOTO 140
  130 NIJP=NIJP+1
C
C  NEW REFLEXION, PUT SPECIFICATION IN REF AND IJP
C
      IJP(1,NIJP)=I
      IJP(2,NIJP)=J
      IJP(3,NIJP)=INM
      IJP(4,NIJP)=0
      IJP(5,NIJP)=0
      IJP(6,NIJP)=MK
      IJP(7,NIJP)=REF(6,ILOC)
      IF(NN.EQ.8)THEN
      PMX(I,J,INM)=REF(7,ILOC)*PIR*(1-2*ITW)+ISW*PI/12
      GEW(I,J,INM)=REF(8,ILOC)
      ENDIF
C
C  STORE ROW, COLUMN, PHASESHIFT AND SIGN IN REF
C
      REF(1,ILOC)=ITW
      REF(2,ILOC)=ISW
      REF(3,ILOC)=I
      REF(4,ILOC)=J
      REF(5,ILOC)=INM
  140 CONTINUE
  200 CONTINUE
  205 CONTINUE
C
C  SORT IJQ AND STORE IBE AND IEI IN IJP
C
      IF(NIJP.EQ.0) GOTO 900
      IB=1
      DO 250 I=1,NIJP
      DO 231 J=1,3
  231 EIJP(J)=IJP(J,I)
      NUM=0
C
C  IBE : BEGIN ADRESS OF DEPENDENTS IN IJQ
C  IEI : ADRESS OF LAST DEPENDENT
C  IEI=0: NO DEPENDENTS
C
      DO 230 J=IB,NIJQ
C
C  LOCATE REFLEXIONS DEPENDENT ON IJP(I)
C
      DO 232 L=1,3
  232 EIJQ(L)=IJQ(L+3,J)
      DO 234 L=1,3
        IF(EIJP(L) .NE. EIJQ(L)) GOTO 230
234   CONTINUE
      DO 233 L=1,8
      ITEMP=IJQ(L,J)
      IJQ(L,J)=IJQ(L,IB+NUM)
  233 IJQ(L,IB+NUM)=ITEMP
      NUM=NUM+1
  230 CONTINUE
      IE=0
      IF(NUM.NE.0) IE=IB+NUM-1
      IJP(4,I)=IB
      IJP(5,I)=IE
      IB=IB+NUM
  250 CONTINUE
C
C  GIVE STRONG REFLEXIONS WHICH APPEAR MOST RANDOM PHASES
C  PREPARATION FOR INFAS
C  REF-CODE IN W3(2,*), NUMBER OF TIMES PRESENT IN W3(1,*)
C
C  SORT REFLEXIONS ON W3(1,..)
C
      DO 319 IR=1,NSTR-1
      DO 318 IV=IR+1,NSTR
      IF(W3(1,IV).GT.W3(1,IR)) THEN
      IH=W3(1,IV)
      W3(1,IV)=W3(1,IR)
      W3(1,IR)=IH
      IH=W3(2,IV)
      W3(2,IV)=W3(2,IR)
      W3(2,IR)=IH
      ENDIF
  318 CONTINUE
  319 CONTINUE
C
C  IJP AND IJQ ARE COMPLETE, RESTORE REF
C
      REWIND ITAPE
      CALL REST(REF,IDUM,ITAPE)
      REWIND ITAPE
  900 CONTINUE
C
C  GIVE LIST OF APPEARANCE
C
C     WRITE(IP,*)'   '
C     WRITE(IP,*)'NUMBER OF TIMES STRONG REFLEXIONS APPEAR IN MATRIX'
C     WRITE(IP,*)'   '
      DO 321 IR=1,NSTR
      IF(W3(1,IR).NE.0) THEN
      CALL UNPK1(REF(5,W3(2,IR)),LH,LK,LL)
C     WRITE(IP,317) LH,LK,LL,W3(1,IR)
      ENDIF
  321 CONTINUE
  317 FORMAT(' ',3I5,': ',I4,' TIMES')
      WRITE(IP,*)'   '
C
C  CALCULATE E0
C
C  FILL DIAGONAL
C
      DO 920 INM=1,NNRM
      DO 910 I=1,NM
      EMX(I,I,INM)=E000
      PMX(I,I,INM)=0.0
  910 CONTINUE
  920 CONTINUE
      RETURN
      END
