      SUBROUTINE OPDETB(NNRM,NM,NHKLF,
     1 EMX,PMX,GEW,AMX,
     2 IJPA,IJQA,W,FAS,GRAD,NIJQA,FDET,DETN,NFS,ICYCMX)
C
C  OPDETB MAXIMIZES THE DETERMINANT
C  SEE ACTA CRYSTALLOGRAPHICA
C  LAPACK ROUTINES ZPOTRF, ZPOTRI ARE USED TO FACTORIZE AND INVERT 
C  KH MATRIX
C
C  NNRM DETERMINANTS ARE MAXIMIZED CONCURRENTLY
C  ONLY REFLEXIONS WITH E>ELIM ARE CONSIDERED BY OPINIT
C
C  PARAMETERS
C
C  NNRM = INPUT =
C
C  EMX(NM,NM,NNRM) = INPUT =
C  E-VALUES IN THE LOWER TRIANGLE
C
C  PMX(NM,NM,NNRM) = INPUT, OUTPUT =
C  INPUT: START PHASES IN RADIANS
C  OUTPUT: REFINED PHASES IN RADIANS
C
C  GEW(NM,NM,NNRM) = INPUT
C  WEIGHTS OF INPUT MIR PHASES
C
C  NM = INPUT =
C  DECLARED DIMENSIONS OF THE MATRICES
C
C  AMX(NM,NM,NNRM) 
C  SCRATCH ARRAY, AFTER DET1, JAAP1 ARE CALLED LOWER TRIANGLE CONTAINS
C  THE INVERSE OF KH MATRIX, THE UPPER CONTAINS ORIGINAL VALUES STILL
C
C  IJPA,IJQA: = INPUT = SEE OPINIT
C  W(NFS,7): SCRATCH
C  FAS: SCRATCH PHASES
c  GRAD: SCRATCH GRADIENTS
C  FDET(NNRM): SCRATCH, INDIVIDUAL DETERMINANT VALUES FOR EACH MATRIX
C
      INTEGER CONV,DIAG,HMAX
      DIMENSION EMX(NM,NM,NNRM)
      DIMENSION PMX(NM,NM,NNRM)
      DIMENSION GEW(NM,NM,NNRM)
      COMPLEX*16 AMX(NM,NM,NNRM)
      DIMENSION IJPA(7,NFS),
     1 IJQA(8,NIJQA),W(NFS,7)
      DIMENSION FAS(NFS),GRAD(NFS)
      DIMENSION DT(9)
      REAL*8 V,VERM,FDET(NNRM),DETN,DETO,GRAD
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)

C
C  DIAG = NUMBER OF TIMES THE ELEMENTS HAVE BEEN DECREASED BY 10%
C
C  THE PHASES
C
C     DATA IFAS /6/
C
C  THE FUDGE FACTORS
C
      DATA IFUD /6/
C
C  W(*,1-3)  SHIFTS OF THE LAST THREE ROUNDS
C
C  THE GRADIENTS
C
C     DATA IGRAD /4/
C
C  STORAGE OF PHASES FROM LAST CYCLE
C
      DATA ICV /5/
C
C  MAXIMUM OF ANY FUDGE FACTOR
C
      DATA FUDMAX /3.0/
C
C  MINIMUM OF ANY FUDGE FACTOR
C
      DATA FUDMIN /.01/
C
C  FUDGE FACTORS ARE MULTIPLIED BY VFUD IF DETERMINANT INCREASES
C
      DATA VFUD /1.1/
C
C  FUDGE FACTORS ARE DIVIDED BY DFUD IF NOT
C
      DATA DFUD /1.5/
C
C  THE MAIN DIAGONAL OF THE MATRIX IS MULTIPLIED BY V IF DET <0
C
      DATA V /0.9/
C
C  REFINEMENT STOPS IF THE CHANGE IN THE VALUE OF DET IS SMALLER THAN
C  GSTOP OVER THE LAST 10 CYCLES
C
      DATA GSTOP /0.01/
C     DATA GSTOP /0.005/
      CONV=0
      VERM=1.0
      PI=4.0*ATAN(1.0)
      TWOPI=2.0*PI
      PID12=PI/12.0
      PID2=PI/2
      THPID2=3*PID2
      ICYCS=0
      DIAG=0
      IF(NFS.NE.0) GOTO 60
      WRITE(LO,*)'NHKLF=  ',NHKLF
      IF(NHKLF.EQ.1)THEN
      CALL DET1(NNRM,NM,EMX,PMX,AMX,
     1 IJPA,NFS,IJQA,NIJQA,FAS,DETO,FDET,IFAIL,VERM)
      IF(IFAIL.EQ.0)THEN
      WRITE(LO,3)DETO
    3 FORMAT(' OPDETB: WITHOUT REFINEMENT THE DETERMINANT IS: ',E12.4)
      ELSE
      WRITE(LO,4)
    4 FORMAT(' OPDETB: PHASES PUT IN RESULT IN A NEGATIVE DETERMINANT')
      ENDIF
      ENDIF
      GOTO 11000
   60 CONTINUE
12000 CONTINUE
      DO 200 I=1,NFS
C
C  GET ROW AND COLUMN OF VARIABLE I
C
      IRY=IJPA(1,I)
      IKO=IJPA(2,I)
      MA=IJPA(3,I)
C
C  CORRECT RESTRICTED PHASE
C
      Z=PMX(IRY,IKO,MA)
      MK=IJPA(6,I)
      IF(MK.EQ.1) GOTO 180
      Y=(MK-1)*PID12
      X=AMOD(Z-Y,TWOPI)
      IF(X.LT.0.0) X=X+TWOPI
      IF(X.GT.PID2.AND.X.LT.THPID2) Y=Y+PI
      Z=Y
  180 CONTINUE
      Z=AMOD(Z,TWOPI)
      IF(Z.LT.0.0) Z=Z+TWOPI
      FAS(I)=Z
  200 CONTINUE
      LK=0
      VERM=1.0
C
C  CALCULATE DETERMINANT
C
230   CONTINUE
      DO 5 I=1,NFS
    5 W(I,IFUD)=0.3
      DO 240 MA=1,NNRM
      DO 240 I=1,NM
      EMX(I,I,MA)=1.0        
  240 CONTINUE
      CALL DET1(NNRM,NM,EMX,PMX,AMX,
     1 IJPA,NFS,IJQA,NIJQA,FAS,DETO,FDET,IFAIL,VERM)
      IF(IFAIL.EQ.0) GOTO 250
      IF(LK.EQ.1) GOTO 800
      DIAG=DIAG+1
      VERM=VERM*V
      GOTO 230  
  250 CONTINUE
      WRITE(LO,1) DETO
    1 FORMAT(' OPDETB: INITIAL VALUE OF THE DETERMINANT=',E20.10)
      ICYC=1
      NC=0
  270 CONTINUE
C
C  STORE PHASE IN W
C
      DO 280 I=1,NFS
280   W(I,ICV)=FAS(I)
C
C  CALCULATE INVERSE MATRIX
C
      CALL JAAP1(AMX,IJPA,
     1 NFS,IJQA,NIJQA,NNRM,NM,GRAD,FDET)
C
C  THE LOWER TRIANGLES OF AMX CONTAIN THE INVERSE OF AMX
C  NOW CALCULATE SHIFTS WITHOUT FUDGEFACTORS
C

      CALL SCHUIF(NNRM,NM,AMX,W(1,1),W(1,ICV),GRAD,IJPA,
     1 IJQA,NFS,NIJQA)
  480 CONTINUE
      DO 475 I=1,NFS
      IF(W(I,IFUD).GT.FUDMIN) GOTO 476
  475 CONTINUE
      GOTO 600
  476 CONTINUE
      DO 457 I=1,NFS
      MK=IJPA(6,I)
      IF(MK.NE.1.AND.CONV.EQ.1) GOTO 457
      HOEK=W(I,ICV)+W(I,1)*W(I,IFUD)
      FAS(I)=AMOD(HOEK,TWOPI)
      IF(FAS(I).LT.0)FAS(I)=FAS(I)+TWOPI
  457 CONTINUE
C
C  NOW RECALCULATE DETERMINANT
C
      CALL DET1(NNRM,NM,EMX,PMX,AMX,
     1 IJPA,NFS,IJQA,NIJQA,FAS,DETN,FDET,IFAIL,VERM)
      IF(IFAIL.EQ.0) GOTO 510
  460 CONTINUE
C
C  DETERMINANT NEGATIVE OR SMALLER THEN THAN OLD VALUE
C
      DO 500 I=1,NFS
  500 W(I,IFUD)=W(I,IFUD)/DFUD
      GOTO 480
  510 CONTINUE
      IF(DETN.GT.DETO) GOTO 520
      GOTO 460
  520 CONTINUE
C
C  NEW VALUE LARGER THAN OLD ONE, GOTO 270 MEANS START NEW CYCLE
C
      NC=MIN0(10,NC+1)
      IF(NC.LT.10) GOTO 540
      X=(DETN-DT(1))/DETN
      IF(X.LT.GSTOP) GOTO 600
      DO 530 I=1,8
      DT(I)=DT(I+1)
  530 CONTINUE
      NC=NC-1
  540 CONTINUE
      DT(NC)=DETN
      IF(ICYC.GE.ICYCMX) GOTO 900
      ICYC=ICYC+1
      ICYCS=ICYCS+1
      DETO=DETN
      DO 560 I=1,NFS
  560 W(I,IFUD)=AMIN1(W(I,IFUD)*VFUD,FUDMAX)
      GOTO 270
  600 CONTINUE
      L=0
      IF(DIAG.GT.0) THEN
      LK=1
      DIAG=DIAG-1
      L=1
      IF(DIAG.EQ.0)THEN 
      VERM=1.0
      ELSE
      VERM=VERM/V
      ENDIF
C
C  MAIN DIAGONAL HAS BEEN INCREASED, DECREASE AND REFINE AGAIN
C
      ENDIF
      IF(L.EQ.1) GOTO 230
C	IF(IFAIL.NE.0)GOTO 800
      CONV=CONV+1
      IF(CONV.GT.1)GO TO 9989
      WRITE(LO,702)
  702 FORMAT(' OPDETB: NOW REFINE WITH SPECIAL REFLEXIONS RESTRICTED')
      GO TO 12000
 9989 CONTINUE
      WRITE(LO,701)
  701 FORMAT(' OPDETB: CONVERGENCE OBTAINED')
      GOTO 9999
  800 CONTINUE
      WRITE(LO,801)
  801 FORMAT(' OPDETB: NO CONVERGENCE, MATRIX IS NOT ',
     1 'POSITIVE DEFINITE')
      GOTO 9999
  900 CONTINUE
      WRITE(LO,901)
  901 FORMAT(' OPDETB: TOO MANY CYCLES')
      GOTO 600
 9999 CONTINUE
      WRITE(LO,10001) ICYCS,DETN
10001 FORMAT(' OPDETB: NUMBER OF CYCLES =',I5,' DETERMINANT=',
     1 E20.10)
      DO 10000 MA=1,NNRM
      DO 10000 I=1,NM
      DO 10000 J=1,I
      PMX(I,J,MA)=AMOD(PMX(I,J,MA),TWOPI)
      IF(PMX(I,J,MA).LT.0.0) PMX(I,J,MA)=PMX(I,J,MA)+TWOPI
10000 CONTINUE
11000 CONTINUE
      RETURN
      END
