C     ************************** SEARCH80 *******************82/11/03***
C       PROGRAM FOR THE AUTOMATIC SEARCH AND INTERPRETATION OF E-MAPS   
C     VERSION    JANUARY   1980                       UNIVERSITY OF YORK
C     ------------------------------------------------------------------
C 31-03-95: Bij wegschrijven clusternummer geen overschrijving JMFT-arra
C 23-02-95: Array NSTORE flink vergroot (KUSER2 ook) 
C 26-01-95: Ook piekhoogte en cluster-nummer naar NOUT 
C 01-12-94: CALL PICTUR weer geactiveerd
C 27-01-94: FORMAT aangepast voor schrijven van pieken naar file NOUT
C 27-01-94: FORMAT aangepast voor schrijven van fragmentgroottes naar 15
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      COMMON /CENT/ TL(3,4),TS(3,24),FS(3,3,24),MLAT,NEQV               
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      CHARACTER*4 IFMT(20) , LTC(7)                                      
      DIMENSION  NSTORE(1001000), XA(3,2000), XB(4,2000) 
      DIMENSION IS(2,3,24), NAFRG(5), KMATCH(20)                        
      EQUIVALENCE (ISYM(1),NSTORE(1)), (IONA(1,1),XA(1,1)),             
     1  (IONP(1,1),XB(1,1)), (ISYM(1),IS(1,1,1))                        
      DATA LTC/'P','A','B','C','I','F','R'/                             
      WRITE(6,4000)                                                     
 4000 FORMAT('1',30X,                                                   
     *'***   S E A R C H 8 0   PROGRAM FOR PEAKSEARCH      ***'//,      
     *37X,'AUTHOR     : P.MAIN,ET AL. ,YORK,UNITED KINGDOM'//,          
     *37X,'DATE       : APRIL 1, 1986 '//,                              
     *37X,'INQUIRIES  : S.GORTER & R. A. G. DE GRAAFF'//,               
     *' ',33('****'),//)                                                
C     PRELIMINARY SECTION - SET UP ALL PROGRAM PARAMETERS               
C     LC = CARD READER                                                  
      LC = 1                                                            
C     LT = LINE PRINTER                                                 
      LT = 6                                                            
C     LIN = INPUT FILE FROM FFT                                         
      LIN = 13                                                          
C     NOUT = OUTPUT FILE TO SFCALC                                      
      NOUT = 14                                                         
C     KUSER1 = MAXIMUM NUMBER OF PEAKS TO BE FOUND + 20, ALSO MAXIMUM   
C     NUMBER OF PEAKS FOR INTERPRETATION AND DIMENSION OF SEVERAL ARRAYS
      KUSER1 = 2000
C     KUSER2 = SIZE OF ARRAY NSTORE FOR STORING 3 SECTIONS OF E-MAP     
      KUSER2 = 1001000     
C     STEREOCHEMICAL CRITERIA - MAX AND MIN DISTANCES AND ANGLES        
      ANGMIN = 85.0                                                     
      ANGMAX = 145.0                                                    
      DMIN = 1.10                                                       
      DMAX = 1.95                                                       
C	READ RESOLUTION OF THE DATA HERE
	READ(40,*)RESO
C     ALL INTERPEAK DISTANCES LESS THAN DMUT ARE PRINTED OUT            
      DMUT = 2.40                                                       
C     IF 2 E-MAP PEAKS ARE CLOSER THAN DM THE SMALLER IS ELIMINATED     
	DM=MAX(RESO,0.85)
C     DM=0.85                                                           
C     IF TWO CLUSTERS ARE CLOSER TOGETHER THAN DFRG INCLUDE MORE PEAKS  
      DFRG = 2.80                                                       
C     LN = NUMBER OF LINES PER INCH ON LINEPRINTER - USED IN PICTUR     
      LN = 8                                                            
C     IWT = RELATIVE WEIGHT OF IDENTIFIED ATOMS TO UNIDENTIFIED         
      IWT = 2                                                           
C     INPUT DATA FROM CARDS                                             
      CALL TRANSL(NPC,NPROJ,MFRN,NA,NOJOIN)                             
      NPC = MIN0(NPC, KUSER1-20)                                        
C     INPUT DATA FROM FFT FILE                                          
      REWIND LIN                                                        
      READ (LIN) ITLE,NUMSET,CELL,NEQV,NCENT,LATT,NATM,TS,IS            
      IF(NUMSET.LT.0) STOP                                              
	IF(NATM.GT.150)NATM=150
      WRITE (LT,720) ITLE, NUMSET, NATM, NA, METAL                      
  720 FORMAT(31H1PEAK SEARCH AND INTERPRETATION,68X, 21HVERSION      JAN
     1 1980//10X,20A4,10X,7HSET NO.,I3///31X,30HNUMBER OF ATOMS TO BE FO
     2UND IS,I6//15X,46HNUMBER OF ATOMIC POSITIONS INPUT FROM CARDS IS, 
     3  I6//18X,43HNUMBER OF HEAVY ATOMS IN ASYMMETRIC UNIT IS, I6)     
      IF (NPC .LE. 0) GO TO 760                                         
      NAT = NPC                                                         
      NPIC = NPC                                                        
      WRITE (LT,740) NPC                                                
  740 FORMAT(/26X,35HNUMBER OF PEAKS TO BE CONSIDERED IS,I6)            
      GO TO 800                                                         
  760 NAT = MIN0((11*NATM+13)/9, KUSER1-20)                             
      NPIC = MIN0((3*NATM+1)/2, KUSER1-20)                              
      WRITE (LT,780)                                                    
  780 FORMAT(/13X,54HNUMBER OF PEAKS TO BE CONSIDERED IS DECIDED BY PROG
     1RAM)                                                              
  800 WRITE (LT,820) DMIN, DMAX, ANGMIN, ANGMAX, DMUT                   
  820 FORMAT(/24H STEREOCHEMICAL CRITERIA,10X,27HMINIMUM BONDING DISTANC
     1E  =,F6.2/34X,27HMAXIMUM BONDING DISTANCE  =,F6.2/40X,            
     2  21HMINIMUM BOND ANGLE  =,F6.1/40X,21HMAXIMUM BOND ANGLE  =,F6.1/
     3 /9X,52HINTERATOMIC  DISTANCES  ARE OUTPUT  WHEN  LESS  THAN,F6.2)
      IF (MFRN .LE. 0) WRITE (LT,830)                                   
  830 FORMAT(/38X,29HNO BOND SEQUENCES TO BE INPUT)                     
      IF(NPROJ.LE.0) WRITE(LT,840)                                      
  840 FORMAT(/11X,56HNUMBER OF PROJECTIONS TO BE OUTPUT IS DECIDED BY PR
     1OGRAM)                                                            
      IF (NPROJ .GT. 0) WRITE (LT,860) NPROJ                            
  860 FORMAT(/9X,55HNUMBER OF PROJECTIONS  OF EACH  CLUSTER TO BE OUTPUT
     1 IS,I3)                                                           
      WRITE (LT,880) CELL,LTC(LATT)                                     
  880 FORMAT(/21H UNIT CELL PARAMETERS,34X,4HA  =,F8.3/55X,4HB  =,F8.3/ 
     1  55X,4HC  =,F8.3/51X,8HALPHA  =,F8.2/52X,7HBETA  =,F8.2/51X,     
     2  8HGAMMA  =,F8.2///29X,65HCENTROSYMMETRIC SPACE GROUP SYMMETRY OP
     3ERATORS WITH LATTICE TYPE ,A1)                                    
      IF (NCENT.EQ.0) WRITE (LT,882)                                    
  882 FORMAT (1H+,25X,3HNON)                                            
      WRITE (LT,883)                                                    
  883 FORMAT (/)                                                        
C     HALVE Y-AXIS BY C.OF.S. OR LATTICE TYPE IF POSSIBLE               
      IHALF=0                                                           
      IF (NCENT.EQ.1) IHALF=-1                                          
      IF (IHALF.NE.0) GOTO 888                                          
      GOTO (888,886,888,886,886,886,888), LATT                          
  886 IHALF = 1                                                         
  888 CALL CENTRE (1,1)                                                 
C     EXPAND TO FULL SPACE GROUP SYMMETRY                               
C     PUT CENTRING TRANSLATIONS IN TL(I,J)                              
      GO TO (940,890,890,890,890,910,920),LATT                          
  890 CALL CENTRE(2,LATT)                                               
      GO TO 940                                                         
  910 CALL CENTRE(2,2)                                                  
      CALL CENTRE(3,3)                                                  
      CALL CENTRE(4,4)                                                  
      GO TO 940                                                         
  920 CONTINUE
	CRIT=0.0
	DO 9222 I=1,3
	J=I+1
	IF(J.GT.3)J=1
	CRIT=CRIT+ABS(CELL(I)-CELL(J))
	CRIT=CRIT+ABS(CELL(I+3)-CELL(J+3))
9222  CONTINUE
      IF(CRIT.GT.0.5)THEN
      CALL CENTRE(2,6)                                                  
      CALL CENTRE(3,7)                                                  
      ENDIF
  940 DO 1000 I=1,NEQV                                                  
      DO 970 J=1,3                                                      
      DO 950 K=1,3                                                      
      FS(K,J,I)=0.0                                                     
  950 CONTINUE                                                          
      DO 960 K=1,2                                                      
      M=IABS(IS(K,J,I))                                                 
      IF(M.GT.0) FS(M,J,I)=FLOAT(ISIGN(1,IS(K,J,I)))                    
  960 CONTINUE                                                          
  970 CONTINUE                                                          
      IF (I.EQ.1.OR.IHALF.NE.0) GOTO 1000                               
C     HALVE Y-AXIS BY SYMMETRY OP. IF POSSIBLE                          
      DO 980 J=1,3                                                      
      IF (IABS(IS(1,J,I)).NE.J.OR.IS(2,J,I).NE.0) GOTO 1000             
  980 CONTINUE                                                          
      IF(IS(1,2,I).EQ.(-2).AND.ABS(TS(2,I)).LT.1E-6) IHALF= -1          
      IF(IS(1,2,I).EQ.2.AND.ABS(TS(2,I)-0.5).LT.1E-6) IHALF=1           
 1000 CONTINUE                                                          
      WRITE(LT,1010)(I,((FS(K,J,I),K=1,3),TS(J,I),J=1,3),I=1,NEQV)      
 1010 FORMAT(13X,I3,6X,3F5.0,F9.4,6X,3F5.0,F9.4,6X,3F5.0,F9.4)          
      NSYM=NEQV*(NCENT+1)*MLAT                                          
C     SET UP CONSTANTS                                                  
      DTOR = 4.0 * ATAN(1.0) / 180.0                                    
      ANGMIN=COS(DTOR*ANGMIN)                                           
      ANGMAX=COS(DTOR*ANGMAX)                                           
      DMIN=DMIN*DMIN                                                    
      DMAX=DMAX*DMAX                                                    
      DMUT = DMUT * DMUT                                                
      CA=COS(DTOR*CELL(4))                                              
      CB=COS(DTOR*CELL(5))                                              
      CC=COS(DTOR*CELL(6))                                              
      V=CELL(1)*CELL(2)*CELL(3)*SQRT(1.0-CA*CA-CB*CB-CC*CC+2.0*CA*CB*CC)
      DXMAX(1)=DM*CELL(2)*CELL(3)*SIN(DTOR*CELL(4))/V                   
      DXMAX(2)=DM*CELL(3)*CELL(1)*SIN(DTOR*CELL(5))/V                   
      DXMAX(3)=DM*CELL(1)*CELL(2)*SIN(DTOR*CELL(6))/V                   
      DM=DM*DM                                                          
      ALN=LN                                                            
C     SET UP MATRIX TO CALCULATE DISTANCES AND ANGLES                   
      DO 1020 I=4,6                                                     
      J=8/I                                                             
      K=15/I                                                            
      T(J,K)=COS(DTOR*CELL(I))                                          
      T(K,J)=T(J,K)                                                     
 1020 CONTINUE                                                          
      DO 1060 I=1,3                                                     
      T(I,I)=1.0                                                        
      DO 1040 J=1,3                                                     
      T(I,J)=T(I,J)*CELL(I)*CELL(J)                                     
 1040 CONTINUE                                                          
 1060 CONTINUE                                                          
      IF (IHALF.NE.0) WRITE (LT,1080)                                   
 1080 FORMAT (/22X,76H** SINCE SPACE GROUP SYMMETRY PERMITS, ONLY HALF T
     1HE MAP WILL BE SEARCHED **)                                       
C     SEARCH MAP FOR PEAK POSITIONS AND RECORD PEAK HEIGHTS             
      CALL PKSRCH(NSTORE,KUSER1,KUSER2,IHALF)                           
      IF (NPIC.LT.NAT) NAT=NPIC                                         
C     INPUT ADDITIONAL PEAK POSITIONS IF DESIRED                        
      IF(NA.LE.0)GO TO 1140                                             
      READ (LC,1100) IFMT                                               
 1100 FORMAT(20A4)                                                      
      NS=NAT+1                                                          
      NAT=NAT+NA                                                        
      DO 1120 I=NS,NAT                                                  
      READ(LC,IFMT)(X(J,I),J=1,3)                                       
      X(4,I)=10000.0                                                    
 1120 CONTINUE                                                          
C     SORT PEAKS IN ORDER OF HEIGHT                                     
      CALL SORT(X,KUSER1,NAT,4)                                         
      NPIC = NAT                                                        
C     ADJUST VALUES OF DXMAX FOR BOND LENGTH CALCULATION                
 1140 FACT=DFRG/SQRT(DM)                                                
      DO 1160 I=1,3                                                     
      DXMAX(I)=FACT*DXMAX(I)                                            
 1160 CONTINUE                                                          
      DFRG = DFRG * DFRG                                                
C     INPUT USERS OWN MOLECULES FOR COMPARISON WITH THOSE               
C     FRAGMENTS FOUND IN THE E-MAP                                      
      IF (MFRN.GT.0) CALL INSEQ(NSEQ,NAFRG)                             
C     IDENTIFY SEPARATE CLUSTERS AND CALCULATE BOND LENGTHS AND ANGLES  
      NN=0                                                              
      NOFRAG=0                                                          
      DO 1200 LOOP=1,KUSER1                                             
      IFRAG(LOOP)=0                                                     
      IUSE(LOOP)=0                                                      
      KEYST(LOOP)=0                                                     
 1200 CONTINUE                                                          
      IF(NOJOIN.EQ.0) CALL CLSTRS(0)                                    
      IF(NOJOIN.EQ.0.AND.MCON.GT.0) GO TO 1230                          
      WRITE(LT,1220) ((X(J,I),J=1,4),I=1,NAT)                           
 1220 FORMAT(//1H ,44X,34HNOJOIN SPECIFIED OR NO BONDS FOUND//          
     1 1H ,52X,16HATOMIC POSITIONS//1H ,46X,1HX,9X,1HY,9X,1HZ,3X,       
     2 6HHEIGHT/(1H ,41X,3F10.4,F8.0))                                  
	Do 1701 I=1,NAT
      WRITE(NOUT,1700) I,(X(J,I),J=1,3)
1701	Continue
      STOP                                                              
C     FOR EACH CLUSTER OF MORE THAN 20 PEAKS WHICH HAS BEEN FOUND,       
C     PLOT THE PEAKS IN PROJECTION, INTERPRET THEM IN TERMS OF          
C     BONDED PEAKS AND COMPARE THEM WITH THOSE ATOMS INPUT BY THE USER  
 1230 DO 1600 NOFRG=1,NFRAG                                             
      NOFRAG = NOFRG                                                    
      IF (KFRAG(NOFRAG) .LE. 20) GO TO 1600                              
      IW = 0                                                            
      NINT=1                                                            
      FOM=0                                                             
 1240 ISTART=0                                                          
C     INTERPRETATION OF PEAKS BEGINS WITH PEAK ISTART                   
C     INTERPRET CLUSTER IN TERMS OF BONDED PEAKS AND ELIMINATE          
C     PEAKS WHICH DO NOT FULFIL DISTANCE AND ANGLE CRITERIA             
 1300 CALL INTERP(ISTART,KUSER1,IW,FOMF)                                
      IF(ISTART.EQ.0)GO TO 1600                                         
C     ACCEPT INTERPRETATION IF FRAGMENT 1 CONTAINS MORE THAN 10 PEAKS.   
      IF (ISTART .EQ. 1) GO TO 1400                                     
      IF (LFRAG(1) .LT. 11) GO TO 1240                                   
C     IF MORE THAN 1 FRAGMENT,SHUFFLE THEM AROUND                       
 1400 IF (MFRAG.LE.1.OR.NN.EQ.0) GOTO 1450                              
      CALL SHFFLE(MAXFRG)                                               
      IF (MAXFRG.EQ.0) GOTO 1450                                        
C     REDO CLUSTER                                                      
C     INITIALISE ARRAYS FOR CLSTRS                                      
 1410 MC=0                                                              
      M=1                                                               
      DO 1418 I=1,NAT                                                   
      IF(IFRAG(I).NE.0.AND.IFRAG(I).NE.-1000) GO TO 1412                
      IUSE(I)=0                                                         
      LW(I)=0                                                           
      LR(I)=0                                                           
      GO TO 1418                                                        
 1412 IF(M.GT.MCON) GO TO 1418                                          
      II=IBOND(M)/4194304                                               
      IF(II.LT.I)GOTO 1416
      IF(II.GT.I)GOTO 1418
C     IF(II-I) 1416,1414,1418                                           
      MC=MC+1                                                           
      IBOND(MC)=IBOND(M)                                                
 1416 M=M+1                                                             
      GO TO 1412                                                        
 1418 CONTINUE                                                          
      MCON=MC                                                           
      CALL CLSTRS(1)                                                    
C     REINTERPRET CLUSTER                                               
      FOM=0.0                                                           
 1420 CALL INTERP(ISTART,KUSER1,IW,FOMF)                                
C     ACCEPT INTERPRETATION IF FRAGMENT 1 CONTAINS MORE                 
C     THAN 10 PEAKS AND MORE THAN ONE NEW PEAK IS INCLUDED IN THE        
C     INTERPRETATION AND THE SIZE OF THE FRAGMENTS IS SIGNIFICANT.      
      IF (ISTART.EQ.0) GOTO 1600                                        
      IF (ISTART.EQ.1) GOTO 1450                                        
      IF (LFRAG(1).GE.11.AND.FOMF*FLOAT(IWT).GT.FOM) GOTO 1450           
      ISTART=0                                                          
      GOTO 1420                                                         
C     PLOT THIS CLUSTER IN THE BEST PROJECTION(S)                       
C1450 CONTINUE
 1450 IF (NPROJ.GE.0.AND.NINT.EQ.1) CALL PICTUR (NPROJ,XA,XB,KUSER1)    
C     COMPARE THE FRAGMENTS FOUND WITH THOSE INPUT BY THE USER          
      IF (MFRN.GT.0) CALL COMPAR(NSEQ,NAFRG,KMATCH)                     
C     OUTPUT BONDING PATTERN AND IDENTIFIED ATOMS                       
      CALL OUTERP(ISTART,KMATCH,FOMF)                                   
      IF(ISTART.GT.0) NINT=NINT+1                                       
      IF (NINT.GT.3) GOTO 1600                                          
      ISTART=0                                                          
      GOTO 1420                                                         
 1600 CONTINUE                                                          
C     OUTPUT INTERPEAK DISTANCES, PEAK HEIGHTS, AND BOND ANGLES         
      CALL BONGLE                                                       
C     CREATE PEAK FILE FOR RECYCLING                                    
      DO 1800 I=1,NAT                                                   
C     FORMAT AANGEPAST VOOR AUTOFOUR, SCHRIJF OOK ALLE ATOMEN WEG
C     IF (IUSE(I).LT.0) WRITE(NOUT,1700) (X(J,I),J=1,3),I               
C1700 FORMAT(1X,1HC,3F10.5,I5)                                          
      IFRAG(I)=IABS(IFRAG(I))                                           
      K=X(4,I)+0.5                                                      
      WRITE(NOUT,1700) I,(X(J,I),J=1,3),K,IFRAG(I)
 1700 FORMAT('C',I3,6X,'       1.0',3F10.5,I10,I10)
 1800 CONTINUE                                                          
      WRITE(6,4001)                                                     
 4001 FORMAT(//,' ',11('****'),'**     E N D    O F    P R O G R A M    
     * **',11('****'))                                                  
      STOP                                                              
      END                                                               
C     ------------------------------------------------------------------
C     FREE FORMAT READING                                               
      SUBROUTINE TRANSL(NPC,NPROJ,MFRN,NA,NOJOIN)                       
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      DIMENSION N(80)
      CHARACTER*4 KX(10),LETT(26),KSP,KD,N
      DATA KX/'0','1','2','3','4','5','6','7','8','9'/,KSP/' '/,KD/'.'/ 
      DATA LETT/'A','B','C','D','E','F','G','H','I','J','K','L',        
     1 'M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/         
      IBL=0                                                             
      NA=0                                                              
      NPROJ=0                                                           
      MFRN=0                                                            
      NPC=0                                                             
      NOJOIN=0                                                          
      METAL = 0                                                         
      KS=1                                                              
      READ(LC,90) N                                                     
   90 FORMAT(80A1)                                                      
  100 KEY=0                                                             
      IKW=0                                                             
      IB=0                                                              
      IDIV=0                                                            
      IM=0                                                              
      IC=0                                                              
  110 DO 200 I=KS,80                                                    
      IF (IKW.EQ.0.AND.N(I).EQ.KSP) GOTO 200                            
      DO 120 K=1,26                                                     
      IF(LETT(K).EQ.N(I)) GO TO 190                                     
  120 CONTINUE                                                          
      IC=1                                                              
      DO 130 K=1,10                                                     
      IF(KX(K).EQ.N(I)) GO TO 180                                       
  130 CONTINUE                                                          
      IF(N(I).EQ.KD) GO TO 170                                          
      IF(N(I).EQ.KSP) GO TO 200                                         
      GO TO 3000                                                        
  170 IM=-1                                                             
      GO TO 200                                                         
  180 IB=10*IB+K-1                                                      
      IF(IM.LT.0) IDIV=IDIV-1                                           
      GO TO 200                                                         
  190 IF(IC.GT.0) GO TO 210                                             
      IBL=1                                                             
      IF(IKW.GT.2) GO TO 200                                            
      IKW=IKW+1                                                         
      KEY=100*KEY+K                                                     
C     TEST FOR END                                                      
      IF(KEY.EQ.51404) RETURN                                           
  200 CONTINUE                                                          
      IF(IBL.EQ.0) RETURN                                               
      KS=1                                                              
      READ(LC,90) N                                                     
      GO TO 110                                                         
  210 KS=I                                                              
C     PEAKS                                                             
      IF(KEY.NE.160501) GO TO 220                                       
      NPC=IB                                                            
      GO TO 100                                                         
C     ATOMS                                                             
  220 IF(KEY.NE.12015) GO TO 230                                        
      NA=IB                                                             
      GO TO 100                                                         
C     PROJECTIONS                                                       
  230 IF(KEY.NE.161815) GO TO 240                                       
      NPROJ=IB                                                          
      GO TO 100                                                         
C     DOUT                                                              
  240 IF(KEY.NE.41521) GO TO 250                                        
      DMUT=FLOAT(IB)*10.0**IDIV                                         
      GO TO 100                                                         
C     DMIN                                                              
  250 IF(KEY.NE.41309) GO TO 260                                        
      DMIN=FLOAT(IB)*10.0**IDIV                                         
      GO TO 100                                                         
C     AMIN                                                              
  260 IF(KEY.NE.11309) GO TO 270                                        
      ANGMIN=FLOAT(IB)*10.0**IDIV                                       
      GO TO 100                                                         
C     DMAX                                                              
  270 IF(KEY.NE.41301) GO TO 280                                        
      DMAX=FLOAT(IB)*10.0**IDIV                                         
      GO TO 100                                                         
C     AMAX                                                              
  280 IF(KEY.NE.11301) GO TO 290                                        
      ANGMAX=FLOAT(IB)*10.0**IDIV                                       
      GO TO 100                                                         
C     METAL                                                             
  290 IF(KEY.NE.130520) GO TO 300                                       
      METAL=IB                                                          
      GO TO 100                                                         
C     MOLECULE                                                          
  300 IF(KEY.NE.131512) GO TO 310                                       
      MFRN=1                                                            
      GO TO 100                                                         
C     NOJOIN                                                            
  310 IF(KEY.NE.141510) GO TO 3000                                      
      NOJOIN=1                                                          
      GO TO 100                                                         
 3000 WRITE(LT,3010) N                                                  
 3010 FORMAT(14H ERROR IN LINE,5X,80A1)                                 
      STOP                                                              
      END                                                               
C     ------------------------------------------------------------------
C     FIND POSITIONS OF PEAKS BY FITTING QUADRATIC FUNCTION TO 19 POINTS
      SUBROUTINE PKSRCH(NR3D,KUSER1,KUSER2,IHALF)                       
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      DIMENSION  NR3D(KUSER2), XS(3), X1(3), IDIFF(19), B(19)           
C     INPUT DIMENSIONS OF E-MAP AND CHECK ARRAY SIZE                    
      READ (LIN) NNX,NNZ,NNY                                            
C     HALVE Y-AXIS IF POSSIBLE                                          
      NNYOLD=NNY                                                        
      IF (IHALF.NE.0) NNY=NNY-NNY/2                                     
      NNXP2 = NNX + 2                                                   
      NXZ = NNXP2 * (NNZ + 2)                                           
      NXZ3 = 3 * NXZ                                                    
      IF (NXZ3 .LE. KUSER2) GO TO 1020                                  
      WRITE (LT,940) KUSER2, NXZ3                                       
  940 FORMAT(//33H NOT ENOUGH ROOM IN ARRAY NSTORE.,10X,18HSPACE AVAILAB
     1LE  =,I7,10X,17HSPACE REQUIRED  =,I7)                             
      STOP                                                              
C     INITIALISE CONSTANTS                                              
 1020 DX = 1.0 / FLOAT(NNX)                                             
      DY = 1.0/FLOAT(NNYOLD)                                            
      DZ = 1.0/FLOAT(NNZ)                                               
      LEVEL = 0                                                         
      LIMIT = MIN0(KUSER1, 2*NAT)                                       
C     SET UP TABLE OF OFFSETS TO LOOK UP 19 POINTS IN E-MAP             
 1100 IDIFF(1) = -NXZ - 1                                               
      IDIFF(2) = -NXZ - NNXP2                                           
      IDIFF(3) = -NXZ                                                   
      IDIFF(4) = -NXZ + NNXP2                                           
      IDIFF(5) = -NXZ + 1                                               
      IDIFF(6) = -NNXP2 - 1                                             
      IDIFF(7) = -1                                                     
      IDIFF(8) = NNXP2 - 1                                              
      IDIFF(9) = -NNXP2                                                 
      IDIFF(10) = 0                                                     
      DO 1120 I=1,9                                                     
      J=20-I                                                            
      IDIFF(J) = -IDIFF(I)                                              
 1120 CONTINUE                                                          
C     INITIALISE VARIABLES                                              
      NO = 0                                                            
      IY = -1                                                           
      NY = 0                                                            
C     IF (LEVEL .EQ. 0) GO TO 1300                                      
C     REPOSITION FILE TO READ IN FIRST TWO SECTIONS AGAIN               
 1200 REWIND LIN                                                        
      READ(LIN)                                                         
      READ(LIN)                                                         
      IF (IY+2.EQ.NNYOLD) GOTO 1400                                     
C     READ IN FIRST SECTION (END OF LAST UNIT CELL)                     
 1300 MAX=NXZ                                                           
      ISKIP=(NNYOLD-1)*NNZ                                              
      DO 1305 I=1,ISKIP                                                 
      READ (LIN)                                                        
 1305 CONTINUE                                                          
 1310 CALL RDSECT(NR3D,MAX,NNXP2,NNZ,NXZ3,KUSER2)                       
      REWIND LIN                                                        
C     READ SECOND SECTION (START OF UNIT CELL)                          
      READ(LIN)                                                         
      READ(LIN)                                                         
      CALL RDSECT(NR3D,MAX,NNXP2,NNZ,NXZ3,KUSER2)                       
C     READ IN THE NEXT SECTION                                          
 1400 MX = MAX - NXZ + NNX + 1                                          
      CALL RDSECT(NR3D,MAX,NNXP2,NNZ,NXZ3,KUSER2)                       
      IY = IY + 1                                                       
      NY = MOD(NY+2, 3) - 1                                             
      KK = NXZ3                                                         
      IF (NY.GT.0) GOTO 1500
      IF(NY.EQ.0)GOTO 1460
      KK = -NXZ3                                                        
 1460 DO 1480 I=1,5                                                     
      IDIFF(I) = IDIFF(I) - KK                                          
 1480 CONTINUE                                                          
      IF (NY .EQ. 0) GO TO 1540                                         
 1500 DO 1520 I=15,19                                                   
      IDIFF(I) = IDIFF(I) - KK                                          
 1520 CONTINUE                                                          
C     SEARCH ONE SECTION OF THE E-MAP                                   
 1540 DO 2000 IZ=1,NNZ                                                  
      MN = MX + 3                                                       
      MX = MX + NNXP2                                                   
      DO 1980 IX=MN,MX                                                  
      IF (NR3D(IX) .LT. LEVEL) GO TO 1980                               
C     LOCATE GRID POINT WITH MAXIMUM DENSITY                            
      DO 1560 I=1,9                                                     
      J = IDIFF(I) + IX                                                 
      IF (NR3D(IX) .LE. NR3D(J)) GO TO 1980                             
 1560 CONTINUE                                                          
      DO 1580 I=11,19                                                   
      J = IDIFF(I) + IX                                                 
      IF (NR3D(IX) .LT. NR3D(J)) GO TO 1980                             
 1580 CONTINUE                                                          
C     FIT QUADRATIC FUNCTION TO 19 POINTS                               
C     DENS = A + C*X + D*Y + E*Z - 0.5*F*(X*X + Y*Y + Z*Z)              
      DO 1600 I=1,19                                                    
      J = IDIFF(I) + IX                                                 
      B(I) = NR3D(J)                                                    
 1600 CONTINUE                                                          
	D=0
	E=0
      B1 = B(3) + B(7) + B(9) + B(11) + B(13) + B(17)                   
      B2 = B(1) + B(2) + B(4) + B(5) + B(6) + B(8) + B(12) + B(14) +    
     1  B(15) + B(16) + B(18) + B(19)                                   
      F = (30.0 * B(10) + 11.0 * B1 - 8.0 * B2) / 63.0                  
      C = (B(5)+B(12)+B(13)+B(14)+B(19)-B(1)-B(6)-B(7)-B(8)-B(15))/10.0 
      DELTAX = C / F                                                    
      IF (ABS(DELTAX) .GT. 1.0) GO TO 1620                              
      D = (B(15)+B(16)+B(17)+B(18)+B(19)-B(1)-B(2)-B(3)-B(4)-B(5))/10.0 
      DELTAY = D / F                                                    
      IF (ABS(DELTAY) .GT. 1.0) GO TO 1620                              
      E = (B(4)+B(8)+B(11)+B(14)+B(18)-B(2)-B(6)-B(9)-B(12)-B(16))/10.0 
      DELTAZ = E / F                                                    
      IF (ABS(DELTAZ) .LE. 1.0) GO TO 1640                              
 1620 DELTAX = 0.0                                                      
      DELTAY = 0.0                                                      
      DELTAZ = 0.0                                                      
 1640 XX = (FLOAT(IX-MN+1) + DELTAX) * DX                               
      YY = (FLOAT(IY) + DELTAY) * DY                                    
      ZZ = (FLOAT(IZ) + DELTAZ) * DZ                                    
C     PEAK HEIGHT INTERPOLATION - NOT SUITABLE IF PEAK SHAPE IS POOR    
C     A = (9.0 * B(10) + 4.0 * B1 - B2) / 21.0                          
C     B(10) = AMAX1(A+0.5*(C*DELTAX+D*DELTAY+E*DELTAZ), B(10))          
      NOP1 = NO+1                                                       
      X(1,NOP1) = XX                                                    
      X(2,NOP1) = YY                                                    
      X(3,NOP1) = ZZ                                                    
      X(4,NOP1) = B(10)                                                 
      IF (NO .EQ. 0) GO TO 1820                                         
      IR=0                                                              
C     IF TWO PEAKS ARE CLOSER THAN DM ANGSTROMS ELIMINATE THE SMALLER   
      DO 1800 K=1,NSYM                                                  
      CALL OPER(K,XS,XX,YY,ZZ)                                          
      DO 1780 I=1,NO                                                    
      DO 1720 L=1,3                                                     
      X1(L) = X(L,I) - XS(L)                                            
 1680 IF (ABS(X1(L)) .LE. 0.5) GO TO 1700                               
      X1(L) = X1(L) - SIGN(1.0, X1(L))                                  
      GO TO 1680                                                        
 1700 IF (ABS(X1(L)) .GT. DXMAX(L)) GO TO 1780                          
 1720 CONTINUE                                                          
      IF (QUAD(X1,X1,T) .GT. DM) GO TO 1780                             
      IF(IR.GT.0) X(4,IR)=0.0                                           
      IR=0                                                              
      IF (B(10) .LE. X(4,I)) GO TO 1980                                 
      X(1,I) = XX                                                       
      X(2,I) = YY                                                       
      X(3,I) = ZZ                                                       
      X(4,I) = B(10)                                                    
      IR=I                                                              
 1780 CONTINUE                                                          
 1800 CONTINUE                                                          
      IF(IR.GT.0) GO TO 1980                                            
 1820 NO = NOP1                                                         
      IF (NO .LT. LIMIT) GO TO 1980                                     
      CALL SORT(X,KUSER1,NO,4)                                          
      NO = NPIC                                                         
      LEVEL = X(4,NPIC) + 0.5                                           
 1980 CONTINUE                                                          
 2000 CONTINUE                                                          
      IF (IY .GE. NNY) GO TO 2100                                       
      IF (IY - NNYOLD .EQ. -2)GOTO 1200
      GOTO 1400
C     SORT PEAKS IN ORDER OF PEAK HEIGHT                                
 2100 CALL SORT(X,KUSER1,NO,4)                                          
      NNN = MIN0(NO,NPIC)                                               
      IF (NNN .EQ. NPIC) RETURN                                         
C     INSUFFICIENT PEAKS FOUND - LOWER SCAN LEVEL AND TRY AGAIN         
      NPIC=NO                                                           
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     INPUT FRAGMENTS FOR COMPARISON WITH THOSE FOUND IN MAP            
      SUBROUTINE INSEQ(NSEQ,NAFRG)                                      
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      DIMENSION ICH(12),LINE(80),LINX(60),IB(6),NAFRG(5)                
      Character*4 ICH,LINE,LINX
      DATA ICH/'0','1','2','3','4','5','6','7','8','9',' ','/'/         
      NSEQ=0                                                            
      WRITE(LT,50)                                                      
   50 FORMAT(1H0,10X,23HMOLECULES INPUT BY USER)                        
      DO 90 J=1,200                                                     
      DO 80 K=1,6                                                       
      IONP(K,J)=0                                                       
   80 CONTINUE                                                          
   90 CONTINUE                                                          
      NAFRG(1)=0                                                        
      NADR=0                                                            
      NUM=0                                                             
      ISL=0                                                             
      IP=0                                                              
  120 READ(LC,130) LINE                                                 
  130 FORMAT(80A1)                                                      
      DO 1000 I=1,80                                                    
      DO 150 J=1,12                                                     
      IF(ICH(J).EQ.LINE(I)) GO TO 160                                   
  150 CONTINUE                                                          
      STOP                                                              
  160 IF(J.EQ.11) GO TO 170                                             
      IF(J.EQ.12) GO TO 180                                             
      NUM=10*NUM+J-1                                                    
      GO TO 1000                                                        
  170 IF(NUM.EQ.0) GO TO 1000                                           
      IF(IP.EQ.0) IAT=NUM                                               
      IF(IP.GT.0) IB(IP)=NUM                                            
      ISL=0                                                             
      NUM=0                                                             
      IP=IP+1                                                           
      GO TO 1000                                                        
  180 IF(IP.EQ.0) GO TO 400                                             
      IF(NUM.EQ.0) GO TO 190                                            
      IB(IP)=NUM                                                        
      IP=IP+1                                                           
      NUM=0                                                             
  190 IP=IP-1                                                           
      IF(IP.EQ.0) GO TO 1000                                            
      DO 250 K=1,IP                                                     
      NAFRG(NSEQ+1)=MAX0(NAFRG(NSEQ+1),IAT,IB(K))                       
      L=0                                                               
  210 L=L+1                                                             
      IF(IONP(L,IAT).EQ.IB(K)) GO TO 250                                
      IF(IONP(L,IAT).GT.0) GO TO 210                                    
      IONP(L,IAT)=IB(K)                                                 
      IX=IB(K)                                                          
      L=0                                                               
  220 L=L+1                                                             
      IF(IONP(L,IX).GT.0) GO TO 220                                     
      IONP(L,IX)=IAT                                                    
  250 CONTINUE                                                          
      IP=0                                                              
      GO TO 1000                                                        
  400 IF(ISL.EQ.(-1)) RETURN                                            
      ISL=-1                                                            
      NSEQ=NSEQ+1                                                       
      N=NAFRG(NSEQ)                                                     
      NX=-29                                                            
      WRITE(LT,720) NSEQ,N                                              
  720 FORMAT(1H0,10X,15HFRAGMENT NUMBER,I4,5X,17HNUMBER OF ATOMS =,I4)  
  730 NX=NX+30                                                          
      NP=MIN0(N,NX+29)                                                  
      WRITE(LT,740) (J,J=NX,NP)                                         
  740 FORMAT(1H0,5HATOMS,5X,30I3)                                       
      DO 780 K=1,6                                                      
      L=0                                                               
      LNO=0                                                             
      DO 750 J=1,60                                                     
      LINX(J)=ICH(11)                                                   
  750 CONTINUE                                                          
      DO 760 J=NX,NP                                                    
      L=L+2                                                             
      IF(IONP(K,J).EQ.0) GO TO 760                                      
      LNO=1                                                             
      II=IONP(K,J)                                                      
      JJ=II/10                                                          
      IF(JJ.GT.0) LINX(L-1)=ICH(JJ+1)                                   
      JJ=II-10*JJ                                                       
      LINX(L)=ICH(JJ+1)                                                 
      IONP(K,J)=0                                                       
      IF(II.LT.J) GO TO 760                                             
      NADR=NADR+1                                                       
      INBOND(NADR)=512*J+II                                             
  760 CONTINUE                                                          
      IF(LNO.EQ.0) GO TO 790                                            
      WRITE(LT,770) (LINX(J),J=1,L)                                     
  770 FORMAT(1H ,8HBONDS TO,2X,30(1X,2A1))                              
  780 CONTINUE                                                          
  790 IF(NP.LT.N) GO TO 730                                             
      NADR=NADR+1                                                       
      INBOND(NADR)=-1000                                                
      NAFRG(NSEQ+1)=0                                                   
      IF(NSEQ.GE.5) RETURN                                              
 1000 CONTINUE                                                          
      GO TO 120                                                         
      END                                                               
C     ------------------------------------------------------------------
C     IDENTIFY SEPARATE BONDED CLUSTERS AND SET UP BONDING ARRAY.       
C     NPASS DETERMINES PATH THROUGH SUBROUTINE.                         
C     NPASS = 0 :SET UP ALL CLUSTERS ; NPASS =1 :REDO CLUSTER NOFRAG    
      SUBROUTINE CLSTRS(NPASS)                                          
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      DIMENSION   IB(3), XS(3), X1(3), X2(3), BSTOR(3),  XSTOR(3)       
      ICHECK=0                                                          
      IF (NPASS.EQ.0) GOTO 1010                                         
      ICHECK=1                                                          
C     REDUCE ISYM ARRAY TO EXCLUDE NOFRAG BONDINGS                      
      NNN=0                                                             
      DO 995 I=1,NN                                                     
      IF (ISYM(I)/250000.EQ.NOFRAG) GOTO 995                            
      NNN=NNN+1                                                         
      ISYM(NNN)=ISYM(I)                                                 
  995 CONTINUE                                                          
      NN=NNN                                                            
      GOTO 1025                                                         
 1000 NAT=NPIC                                                          
C     CLEAR ARRAYS                                                      
 1010 NN=0                                                              
      MCON=0                                                            
      DO 1020 I=1,NAT                                                   
      IFRAG(I)=0                                                        
      ICON(I)=0                                                         
      LW(I) = 0                                                         
      LR(I) = 0                                                         
 1020 CONTINUE                                                          
C     APPLY DISTANCE CRITERION TO PEAKS TO IDENTIFY SEPARATE CLUSTERS   
C     PEAKS WITHIN DISTANCE DMAX ARE POSSIBLE BONDED PEAKS              
      NFRAG=0                                                           
      NOFRAG=0                                                          
 1025 NATM1=NAT-1                                                       
C     START A NEW CLUSTER AT ATOM II                                    
      DO 1180 II=1,NATM1                                                
      IF (IFRAG(II).EQ.(-1000)) GOTO 1030                               
      IF (ICHECK.EQ.1.OR.IFRAG(II).NE.0) GOTO 1180                      
      NOFRAG=NOFRAG+1                                                   
      NFRAG=NFRAG+1                                                     
      IF(NFRAG.GT.20)RETURN
 1030 ICHECK=0                                                          
      IFRAG(II)=NOFRAG                                                  
C     KOUNT RECORDS NUMBER OF PEAKS IN PRESENT CLUSTER.                 
      KOUNT=1                                                           
      I=II                                                              
      IBEGIN=II                                                         
      IF (NPASS.EQ.1) IBEGIN=1                                          
 1040 DO 1140 J=IBEGIN,NAT                                              
C     DO NOT CONSIDER PEAK PAIRS MORE THAN ONCE                         
      IF (IFRAG(J).LT.0.AND.IFRAG(J).NE.(-1000)) GOTO 1140              
      JMOVE = 0                                                         
      KSYM=0                                                            
      DO 1120 K=1,NSYM                                                  
C     OMIT THE IDENTITY OPERATION WHEN I & J ARE THE SAME               
      IF (I.EQ.J.AND.K.EQ.1) GOTO 1120                                  
C     CALC K'TH SYMM POSITION OF J'TH PEAK & MOVE AS CLOSE              
C     TO I'TH PEAK AS POSSIBLE BY LATTICE TRANSLATIONS                  
      IF(JSYMM(I,J,K,IB,XS,X1).NE.0) GO TO 1120                         
C     CALCULATE DISTANCE BETWEEN PEAKS I & J                            
      DIST=QUAD(X1,X1,T)                                                
      IF (DIST.GT.DFRG) GOTO 1120                                       
C     PEAK J IS CLOSE TO CLUSTER NOFRAG                                 
      LR(J)=1                                                           
C     DO NOT CONSIDER PEAKS OUTSIDE BONDING DISTANCE                    
C     OR PEAKS LYING ON SYMMETRY ELEMENTS                               
      IF (DIST.GT.DMAX) GOTO 1120                                       
      IF (DIST.LT.0.04) GOTO 1120                                       
C     PEAKS I & J ARE WITHIN BONDING DISTANCE-ADD TO CLUSTER            
      IF (IABS(IFRAG(J)).EQ.NOFRAG) GOTO 1080                           
      IF (IFRAG(J).EQ.(-1000)) GOTO 1060                                
C     PEAK J CAN BE MOVED, SO MOVE IT & RECORD SYMM. OP.                
      JMOVE=1                                                           
      KSYM=K                                                            
      DO 1050 L=1,3                                                     
      XSTOR(L)=XS(L)                                                    
      BSTOR(L)=FLOAT(IB(L)-5)                                           
 1050 CONTINUE                                                          
C     ADD J TO CLUSTER                                                  
 1060 IFRAG(J)=NOFRAG                                                   
      KOUNT=KOUNT+1                                                     
C     IF PEAK MOVED, ADD TO BONDING ARRAY                               
      IF (KSYM.EQ.K) GOTO 1100                                          
 1080 JBND=100000*IB(1)+10000*IB(2)+1000*IB(3)+K                        
      IF (JBND.EQ.555001) GOTO 1100                                     
C     CLUSTER NOFRAG BONDS TO ITSELF THROUGH I & J - RECORD IN ISYM     
      NN=NN+1                                                           
      IF(I.LT.J) ISYM(NN)=250000*NOFRAG+500*I+J                         
      IF(I.GE.J) ISYM(NN)=250000*NOFRAG+500*J+I                         
      GOTO 1120                                                         
 1100 IF(I.EQ.J) GO TO 1120                                             
      IDIST=1000.0*SQRT(DIST)+0.5                                       
      MCON=MCON+1                                                       
      IBOND(MCON)=(512*I+J)*8192+IDIST                                  
      MCON=MCON+1                                                       
      IBOND(MCON)=(512*J+I)*8192+IDIST                                  
 1120 CONTINUE                                                          
      IF (JMOVE .EQ. 0) GO TO 1140                                      
      DO 1125 L=1,3                                                     
      X(L,J) = XSTOR(L)                                                 
 1125 CONTINUE                                                          
C     IF ONE PEAK IN A FRAGMENT MOVES,MOVE ALL THE REST                 
      IF (NPASS.NE.1.OR.JFRAG(J).EQ.0) GOTO 1140                        
      DO 1135 LOOP=1,NAT                                                
      IF (LOOP.EQ.J) GOTO 1135                                          
      IF (IFRAG(LOOP).NE.0) GOTO 1135                                   
      IF (JFRAG(LOOP).NE.JFRAG(J)) GOTO 1135                            
      CALL OPER(KSYM,XS,X(1,LOOP),X(2,LOOP),X(3,LOOP))                  
      DO 1130 L=1,3                                                     
      X(L,LOOP)=XS(L)                                                   
 1130 CONTINUE                                                          
 1135 CONTINUE                                                          
 1140 CONTINUE                                                          
C     PEAK I HAS BEEN COMPLETELY DEALT WITH                             
      IFRAG(I)=-IFRAG(I)                                                
C     CHOOSE NEXT PEAK IN CLUSTER                                       
      DO 1160 I=1,NAT                                                   
      IF(IFRAG(I).EQ.NOFRAG)GO TO 1040                                  
 1160 CONTINUE                                                          
C     CHECK FOR CLOSE APPROACHES BETWEEN CLUSTERS                       
      IF (NPASS.EQ.1) GOTO 1178                                         
      IF (NAT .EQ. NPIC) GO TO 1178                                     
      DO 1175 I=1,NAT                                                   
      IF (KOUNT.LE.4) GO TO 1170                                        
      IF (IABS(IFRAG(I)) .NE. NOFRAG) GO TO 1165                        
      IF (LW(I) .EQ. 0) GO TO 1170                                      
C     CLUSTERS ARE CLOSE TOGETHER - INCREASE NUMBER OF PEAKS            
      GO TO 1000                                                        
 1165 IF (LW(I) .EQ. 0) LW(I) = LR(I)                                   
 1170 LR(I) = 0                                                         
 1175 CONTINUE                                                          
 1178 IF(KOUNT.EQ.1)GO TO 1179                                          
      KFRAG(NOFRAG)=KOUNT                                               
      GOTO 1180                                                         
C     SINGLE PEAKS ARE GIVEN A CLUSTER NUMBER OF ZERO                   
 1179 IFRAG(II)=0                                                       
      NFRAG=NFRAG-1                                                     
      NOFRAG=NOFRAG-1                                                   
 1180 CONTINUE                                                          
      DO 1240 I=1,NAT                                                   
      IFRAG(I)=IABS(IFRAG(I))                                           
 1240 CONTINUE                                                          
C     PUT ENTRIES IN IBOND ARRAY IN ORDER OF PEAK HEIGHT                
      IF(MCON.GT.0) CALL ISORT(IBOND,MCON)                              
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     INTERPRET CLUSTER IN TERMS OF BONDED PEAKS AND ELIMINATE          
C     PEAKS WHICH DO NOT FULFIL DISTANCE AND ANGLE CRITERIA             
      SUBROUTINE INTERP(ISTART,KUSER1,IW,FOMF)                          
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      DIMENSION X1(3),X2(3)                                             
C     COPY CLUSTER INTO NEW ARRAY                                       
      M=1                                                               
      J=0                                                               
      DO 980 I=1,NAT                                                    
      JCON(I)=0                                                         
      JFRAG(I)=0                                                        
      ICON(I)=J                                                         
      IF (IFRAG(I) .NE. NOFRAG) GO TO 980                               
      IF(ISTART.EQ.0.AND.IUSE(I).EQ.0)ISTART=I                          
      IF (ISTART.LE.METAL) ISTART=0                                     
  950 IF(M.GT.MCON) GO TO 980                                           
      II=IBOND(M)/4194304                                               
      IF(II.LT.I)GOTO 970
      IF(II.GT.I)GOTO 980
C     IF(II-I) 970,960,980                                              
  960 JCON(I)=JCON(I)+1                                                 
      J=J+1                                                             
      JBOND(J)=MOD(IBOND(M),4194304)                                    
      IF (I.EQ.ISTART.AND.JBOND(J)/8192.LE.METAL) ISTART = 0            
  970 M=M+1                                                             
      GO TO 950                                                         
  980 CONTINUE                                                          
      ICON(NAT+1)=J                                                     
      IF (ISTART.EQ.0) RETURN                                           
      MFRAG=0                                                           
      IDMIN=1000.0*SQRT(DMIN)+0.5                                       
C     START INTERPRETATION OF NEW SET OF PEAKS AT PEAK II               
      II=ISTART                                                         
      IF (METAL.EQ.0) GOTO 1080                                         
      DO 1020 I=1,METAL                                                 
      IF (IFRAG(I).NE.NOFRAG) GOTO 1020                                 
      JCON(I)=0                                                         
      KS=ICON(I)+1                                                      
      KL=ICON(I+1)                                                      
      IF(KS.GT.KL) GO TO 1010                                           
      DO 1000 J=KS,KL                                                   
      L=JBOND(J)/8192                                                   
      CALL ELIM(L,JFRAG(L),JCON,JBOND,ICON,KUSER1)                      
 1000 CONTINUE                                                          
 1010 CALL ELIM(I,JFRAG(I),JCON,JBOND,ICON,KUSER1)                      
 1020 CONTINUE                                                          
      GOTO 1080                                                         
 1040 II=0                                                              
 1060 II=II+1                                                           
      IF(II.GT.NAT)GO TO 1620                                           
      IF(JFRAG(II).NE.0)GO TO 1060                                      
      IF (JCON(II) .LE. 0) GO TO 1060                                   
 1080 MFRAG=MFRAG+1                                                     
      JFRAG(II)=MFRAG                                                   
      LFRAG(MFRAG)=1                                                    
      I=II                                                              
 1100 KS=ICON(I)+1                                                      
      KL=ICON(I+1)                                                      
C     APPLY MINIMUM DISTANCE CRITERION TO PEAKS AROUND THE ITH PEAK     
      DO 1140 J=KS,KL                                                   
      IF(JBOND(J).EQ.0) GO TO 1140                                      
      IDIST=MOD(JBOND(J),8192)                                          
      IF(IDIST.GE.IDMIN)GO TO 1140                                      
      L=JBOND(J)/8192                                                   
C     PEAKS I AND L ARE TOO CLOSE - ELIMINATE L                         
      CALL ELIM(L,JFRAG(L),JCON,JBOND,ICON,KUSER1)                      
 1140 CONTINUE                                                          
C     APPLY ANGLE CRITERIA TO PEAKS AROUND THE ITH PEAK                 
      IF(KS.EQ.KL)GO TO 1480                                            
C     CONSIDER THE ANGLES FRAGMENT - I - ANYTHING                       
      DO 1360 J=KS,KL                                                   
      IF(JBOND(J).EQ.0) GO TO 1360                                      
      JJ=JBOND(J)/8192                                                  
C     FIND A FRAGMENT PEAK                                              
      IF(IABS(JFRAG(JJ)).NE.MFRAG)GO TO 1360                            
C     SET UP VECTOR JJ - I FOR ANGLE CALCULATION                        
      DO 1300 L=1,3                                                     
      X1(L) = X(L,JJ) - X(L,I)                                          
 1300 CONTINUE                                                          
      VEC1=0.001*FLOAT(MOD(JBOND(J),8192))                              
      DO 1340 K=KS,KL                                                   
      IF(JBOND(K).EQ.0) GO TO 1340                                      
      KK=JBOND(K)/8192                                                  
      IF(JJ.EQ.KK)GO TO 1340                                            
C     CALCULATE COSINE OF ANGLE BETWEEN PEAKS JJ - I - KK               
      DO 1320 L=1,3                                                     
      X2(L)=X(L,KK)-X(L,I)                                              
 1320 CONTINUE                                                          
      VEC2=0.001*FLOAT(MOD(JBOND(K),8192))                              
      COSA=QUAD(X1,X2,T)/(VEC1*VEC2)                                    
C     IF ANGLE IS WITHIN LIMITS CONTINUE TESTING                        
      IF(COSA.GE.ANGMAX.AND.COSA.LE.ANGMIN)GO TO 1340                   
C     ELIMINATE KK IF IT IS NOT IN THE FRAGMENT                         
      IF(IABS(JFRAG(KK)).NE.MFRAG)GO TO 1330                            
      LFRAG(MFRAG) = LFRAG(MFRAG) - 1                                   
C     KK IS IN THE FRAGMENT - HAS IT ALREADY BEEN CONSIDERED            
      IF(JFRAG(KK).GT.0)GO TO 1330                                      
C     KK HAS ALREADY BEEN FULLY CONSIDERED FOR THE FRAGMENT-ELIMINATE I 
      CALL ELIM(I,JFRAG(I),JCON,JBOND,ICON,KUSER1)                      
      GO TO 1500                                                        
 1330 CALL ELIM(KK,JFRAG(KK),JCON,JBOND,ICON,KUSER1)                    
 1340 CONTINUE                                                          
 1360 CONTINUE                                                          
C     CONSIDER THE ANGLES NONFRAG - I - NONFRAG                         
      KLM1=KL-1                                                         
      DO 1460 J=KS,KLM1                                                 
      IF(JBOND(J).EQ.0) GO TO 1460                                      
      JJ=JBOND(J)/8192                                                  
C     FIND A NON-FRAGMENT PEAK                                          
      IF(IABS(JFRAG(JJ)).EQ.MFRAG)GO TO 1460                            
C     ADD PEAK TO FRAGMENT                                              
      JFRAG(JJ)=MFRAG                                                   
      LFRAG(MFRAG)=LFRAG(MFRAG)+1                                       
C     SET UP VECTOR JJ - I FOR ANGLE CALCULATION                        
      DO 1400 L=1,3                                                     
      X1(L)=X(L,JJ)-X(L,I)                                              
 1400 CONTINUE                                                          
      VEC1=0.001*FLOAT(MOD(JBOND(J),8192))                              
      JP1=J+1                                                           
      DO 1440 K=JP1,KL                                                  
      IF(JBOND(K).EQ.0) GO TO 1440                                      
      KK = JBOND(K)/8192                                                
C     FIND A NON-FRAGMENT PEAK                                          
      IF(IABS(JFRAG(KK)).EQ.MFRAG)GO TO 1440                            
C     CALCULATE COSINE OF ANGLE BETWEEN PEAKS JJ - I - KK               
      DO 1420 L=1,3                                                     
      X2(L)=X(L,KK)-X(L,I)                                              
 1420 CONTINUE                                                          
      VEC2=0.001*FLOAT(MOD(JBOND(K),8192))                              
      COSA=QUAD(X1,X2,T)/(VEC1*VEC2)                                    
C     IF ANGLE IS OUTSIDE LIMITS ELIMINATE KK                           
      IF(COSA.LT.ANGMAX.OR.COSA.GT.ANGMIN)CALL ELIM(KK,JFRAG(KK),       
     1  JCON,JBOND,ICON,KUSER1)                                         
 1440 CONTINUE                                                          
 1460 CONTINUE                                                          
C     SEE IF LAST PEAK CAN JOIN FRAGMENT                                
 1480 JJ=JBOND(KL)/8192                                                 
	IF(JJ.LE.0)GOTO 1490
      IF(JCON(JJ).LE.0.OR.JFRAG(JJ).NE.0)GO TO 1490                     
      JFRAG(JJ)=MFRAG                                                   
      LFRAG(MFRAG)=LFRAG(MFRAG)+1                                       
C     PEAK I HAS NOW BEEN FULLY CONSIDERED                              
 1490 JFRAG(I)=-JFRAG(I)                                                
C     FIND LARGEST PEAK IN CLUSTER NOT YET DEALT WITH                   
 1500 DO 1520 I=1,NAT                                                   
      IF(JFRAG(I).EQ.MFRAG)GO TO 1100                                   
 1520 CONTINUE                                                          
      IF(LFRAG(MFRAG).GT.1)GO TO 1600                                   
C     SINGLE PEAKS ARE GIVEN A FRAGMENT NUMBER OF ZERO                  
      JFRAG(II)=0                                                       
      MFRAG=MFRAG-1                                                     
 1600 CONTINUE
      IF(II.NE.ISTART)GOTO 1060
      GOTO 1040
C     INTERPRETATION COMPLETE                                           
 1620 FOMF=0.0                                                          
      KKK=0                                                             
      DO 1640 I=1,NAT                                                   
      JFRAG(I)=IABS(JFRAG(I))                                           
      J=JFRAG(I)                                                        
      IF(J.EQ.0)goto 1640
      IF(LFRAG(J).LT.4) GO TO 1640                            
      FOMF=FOMF+ALOG10(FLOAT(LFRAG(J)))*X(4,I)                          
      IF(IUSE(I).EQ.0) KKK=1                                            
 1640 CONTINUE                                                          
      IF(KKK.EQ.0) FOMF=0.0                                             
      IF(IUSE(ISTART).EQ.0)IUSE(ISTART)=1                               
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     THIS ROUTINE SHUFFLES FRAGMENTS ACCORDING TO THE BONDINGS         
C     STORED IN ISYM, ALTERING FRAGMENT NUMBER AS WELL                  
      SUBROUTINE SHFFLE(MAXFRG)                                         
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      DIMENSION XTEMP(3),TN(3),IB(3),XS(3),X1(3)                        
      MAXFRG=0                                                          
C     CONSIDER EACH SYMM. OP. IN TURN                                   
      DO 700 K1=1,NN                                                    
C     OBTAIN PEAKS IN RELEVANT SYMM OPS AND CLUSTER                     
      ITEMP=ISYM(K1)/250000                                             
      IF (ITEMP.NE.NOFRAG) GOTO 700                                     
      I1=MOD(ISYM(K1),250000)/500                                       
      I2=MOD(ISYM(K1),500)                                              
C     IF SAME FRAGMENT, DISREGARD SYMM. OP.                             
      IF(JFRAG(I1).EQ.JFRAG(I2)) GOTO 700                               
C     DETERMINE WHICH FRAGMENT TO MOVE, AND OBTAIN CORRECT              
C     SYMMETRY OPERATION TO DO SO,ACCOUNTING FOR SINGLE PEAKS.          
  100 JI1=JFRAG(I1)                                                     
      JI2=JFRAG(I2)                                                     
      IF (JI1.EQ.0) GOTO 150                                            
      IF (JI2.EQ.0) GOTO 200                                            
      IF(LFRAG(JI1).GE.LFRAG(JI2)) GOTO 200                             
  150 IAT=I1                                                            
      IOTHER=I2                                                         
      GOTO 300                                                          
  200 IAT=I2                                                            
      IOTHER=I1                                                         
  300 JIAT=JFRAG(IAT)                                                   
      JOTHER=JFRAG(IOTHER)                                              
C     IDENTIFY ALL PEAKS IN FRAGMENT TO BE MOVED, AND MOVE THEM         
      DO 345 K=1,NSYM                                                   
      IF(JSYMM(IOTHER,IAT,K,IB,XS,X1).NE.0) GO TO 345                   
      IF (QUAD(X1,X1,T).LE.DMAX) GOTO 347                               
  345 CONTINUE                                                          
  347 DO 350 L=1,3                                                      
      X(L,IAT)=XS(L)                                                    
      TN(L)=FLOAT(IB(L)-5)                                              
  350 CONTINUE                                                          
      JFRAG(IAT)=JOTHER                                                 
      IF (JIAT.EQ.0) GOTO 520                                           
      DO 500 K2=1,NAT                                                   
      IF (JFRAG(K2).NE.JIAT) GOTO 500                                   
      CALL OPER(K,XTEMP,X(1,K2),X(2,K2),X(3,K2))                        
      DO 450 K5=1,3                                                     
      X(K5,K2)=XTEMP(K5)+TN(K5)                                         
  450 CONTINUE                                                          
      JFRAG(K2)=JOTHER                                                  
  500 CONTINUE                                                          
C     CORRECT LFRAG ARRAY                                               
      LFRAG(JOTHER)=LFRAG(JOTHER)+LFRAG(JIAT)                           
      LFRAG(JIAT)=0                                                     
      GOTO 550                                                          
  520 LFRAG(JOTHER)=LFRAG(JOTHER)+1                                     
  550 IF (LFRAG(JOTHER).GT.MAXFRG) MAXFRG=LFRAG(JOTHER)                 
C     CLOSE UP LFRAG & JFRAG ARRAYS                                     
      IF (JIAT.EQ.0) GOTO 700                                           
      MFRAG=MFRAG-1                                                     
      DO 620 K7=1,MFRAG                                                 
      IF (LFRAG(K7).NE.0) GOTO 620                                      
      LFRAG(K7)=LFRAG(K7+1)                                             
      LFRAG(K7+1)=0                                                     
  620 CONTINUE                                                          
      DO 650 K8=1,NAT                                                   
      IF (JFRAG(K8).LT.JIAT) GOTO 650                                   
      JFRAG(K8)=JFRAG(K8)-1                                             
  650 CONTINUE                                                          
  700 CONTINUE                                                          
C     RETURN IF NO SHUFFLING HAS TAKEN PLACE                            
      IF (MAXFRG.EQ.0) RETURN                                           
C     PUTS IFRAG -VE FOR ALL PEAKS IN CLUSTERS OTHER THAN NOFRAG,       
C     ZEROS IFRAG FOR MOVABLE PEAKS, AND PUTS IFRAG                     
C     EQUAL TO -1000 FOR THE LARGEST COMBINED FRAGMENT.                 
      DO 900 LOOP=1,MFRAG                                               
      IF (LFRAG(LOOP).NE.MAXFRG) GOTO 900                               
      GOTO 1000                                                         
  900 CONTINUE                                                          
 1000 JCOMB=LOOP                                                        
      DO 1300 LOOP=1,NAT                                                
      IF (IFRAG(LOOP).EQ.NOFRAG) GOTO 1100                              
      IFRAG(LOOP)=-IFRAG(LOOP)                                          
      GOTO 1300                                                         
 1100 IF (JFRAG(LOOP).EQ.JCOMB) GOTO 1200                               
      IFRAG(LOOP)=0                                                     
      GOTO 1300                                                         
 1200 IFRAG(LOOP)=-1000                                                 
 1300 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
      SUBROUTINE COMPAR(NSEQ,NAFRG,KMATCH)                              
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      DIMENSION NAFRG(5), KMATCH(20)                                    
      DO 2000 MOFRAG=1,MFRAG                                            
      KMATCH(MOFRAG)=0                                                  
      IF(LFRAG(MOFRAG).LT.5) GO TO 2000                                 
      M=0                                                               
      DO 100 I=1,NAT                                                    
      NU(I)=0                                                           
      IF(JFRAG(I).NE.MOFRAG) GO TO 100                                  
      M=M+1                                                             
      NO(M)=I                                                           
      NU(I)=M                                                           
  100 CONTINUE                                                          
      DO 150 I=1,NAT                                                    
      IF(NU(I).EQ.0) GO TO 150                                          
      KEYST(I)=0                                                        
      M=NU(I)                                                           
      DO 130 J=1,6                                                      
      IONP(J,M)=0                                                       
  130 CONTINUE                                                          
      K=0                                                               
      KS=ICON(I)+1                                                      
      KL=ICON(I+1)                                                      
      DO 140 J=KS,KL                                                    
      MC=JBOND(J)/8192                                                  
      IF(MC.LE.0) GO TO 140                                             
      K=K+1                                                             
      IONP(K,M)=NU(MC)                                                  
  140 CONTINUE                                                          
  150 CONTINUE                                                          
      CALL CANON(M,MR)                                                  
      KM=0                                                              
      DO 200 I=1,M                                                      
      K=NU(I)                                                           
      MU(K)=NO(I)                                                       
      LW(I)=LX(I)                                                       
      IF(I.LE.6.OR.I.LE.MR) KM=KM+LW(I)                                 
      DO 190 J=1,6                                                      
      IONA(J,I)=IONP(J,I)                                               
  190 CONTINUE                                                          
  200 CONTINUE                                                          
      NADR=0                                                            
      MSTOR=1                                                           
      MERIT=1                                                           
      DO 1800 NX=1,NSEQ                                                 
      N=NAFRG(NX)                                                       
      DO 350 I=1,N                                                      
      LL(I)=0                                                           
      DO 340 J=1,6                                                      
      IONP(J,I)=0                                                       
  340 CONTINUE                                                          
  350 CONTINUE                                                          
  360 NADR=NADR+1                                                       
      IF(INBOND(NADR).LT.(-999)) GO TO 370                              
      I=INBOND(NADR)/512                                                
      J=MOD(INBOND(NADR),512)                                           
      K=LL(I)+1                                                         
      IONP(K,I)=J                                                       
      LL(I)=K                                                           
      K=LL(J)+1                                                         
      IONP(K,J)=I                                                       
      LL(J)=K                                                           
      GO TO 360                                                         
  370 CALL CANON(N,NR)                                                  
      KN=0                                                              
      DO 410 I=1,N                                                      
      IF(I.LE.6.OR.I.LE.NR) KN=KN+LX(I)                                 
  410 CONTINUE                                                          
      IF(KN.GE.KM) CALL TELL(N,NR,M,MR,MERIT,1,IONA,IONP,LW)            
      IF(KN.LT.KM) CALL TELL(M,MR,N,NR,MERIT,2,IONP,IONA,LX)            
      IF(MERIT.LE.MSTOR) GO TO 1800                                     
      MSTOR=MERIT+1                                                     
      DO 450 I=1,N                                                      
      K=NU(I)                                                           
      NO(K)=I                                                           
  450 CONTINUE                                                          
      DO 500 I=1,NAT                                                    
      IF(JFRAG(I).EQ.MOFRAG) KEYST(I)=0                                 
  500 CONTINUE                                                          
      DO 1700 I=1,M                                                     
      IF(MO(I).EQ.0) GO TO 1700                                         
      K=MO(I)                                                           
      J=MU(I)                                                           
      KEYST(J)=NO(K)                                                    
 1700 CONTINUE                                                          
      KMATCH(MOFRAG)=NX                                                 
 1800 CONTINUE                                                          
 2000 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     PLOT PROJECTION OF CLUSTER FOUND ONTO LEAST SQUARES PLANE         
C     PLOT ALSO AN ORTHOGONAL  PROJECTION IF THE ATOMIC OVERLAP IS LARGE
      SUBROUTINE PICTUR(NPROJ,XA,XB,KUSER1)                             
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      CHARACTER*4 IFMT,IBLANK,IEND
      DIMENSION IFMT(120), XA(3,KUSER1), XB(4,KUSER1),                  
     1  B(3,3), V(3,3), IND(3), SUM(3), XMAX(3), XMIN(3)                
      DATA IFMT(1)/'(1H+'/,IFMT(2)/','/,IBLANK/'1X,'/,IEND/'I3)'/       
C     DO NOT OUTPUT PICTURES WITH LESS THAN 8 PEAKS                     
      NUM = KFRAG(NOFRAG)                                               
   10 IF (NUM .LT. 8) RETURN                                            
      ANUM = NUM                                                        
C     SET UP ORTHOGONALISATION MATRIX                                   
      COSW=(COS(DTOR*CELL(5))-COS(DTOR*CELL(6))*COS(DTOR*CELL(4)))/(SIN(
     1DTOR*CELL(6))*SIN(DTOR*CELL(4)))                                  
      SINW=SQRT(1.0-COSW**2)                                            
      A11=CELL(1)*SINW*SIN(DTOR*CELL(6))                                
      A21=CELL(1)*COS(DTOR*CELL(6))                                     
      A22=CELL(2)                                                       
      A23=CELL(3)*COS(DTOR*CELL(4))                                     
      A31=CELL(1)*COSW*SIN(DTOR*CELL(6))                                
      A33 = CELL(3) * SIN(DTOR*CELL(4))                                 
C     INITIALISE ARRAYS                                                 
      DO 1020 J=1,3                                                     
      SUM(J)=0.0                                                        
      XMAX(J)=-10000.0                                                  
      XMIN(J)=10000.0                                                   
      DO 1000 I=1,3                                                     
      B(I,J)=0.0                                                        
 1000 CONTINUE                                                          
 1020 CONTINUE                                                          
C     CONVERT PEAK COORDINATES TO AN ORTHOGONAL SYSTEM AND SET UP       
C     THE MATRIX FOR THE PLANE FITTING CALCULATIONS                     
      DO 1080 I=1,NAT                                                   
      IF(IFRAG(I).NE.NOFRAG)GO TO 1080                                  
      XA(1,I)=X(1,I)*A11                                                
      XA(2,I)=X(1,I)*A21+X(2,I)*A22+X(3,I)*A23                          
      XA(3,I)=X(1,I)*A31+X(3,I)*A33                                     
      DO 1060 J=1,3                                                     
      SUM(J)=SUM(J)+XA(J,I)                                             
      DO 1040 K=1,3                                                     
      B(J,K)=B(J,K)+XA(J,I)*XA(K,I)                                     
 1040 CONTINUE                                                          
 1060 CONTINUE                                                          
 1080 CONTINUE                                                          
      DO 1120 J=1,3                                                     
      DO 1100 K=1,3                                                     
      B(J,K)=B(J,K)-SUM(J)*SUM(K)/ANUM                                  
 1100 CONTINUE                                                          
 1120 CONTINUE                                                          
C     CALCULATE EIGENVECTORS AND EIGENVALUES OF MATRIX                  
      CALL EIGEN(B,V,IND)                                               
C     CONVERT COORDINATES TO AXES GIVEN BY EIGENVECTORS                 
      K=0                                                               
      DO 1180 I=1,NAT                                                   
      IF (IFRAG(I).NE.NOFRAG) GOTO 1180                                 
      K=K+1                                                             
      XB(4,K)=I                                                         
      DO 1140 J=1,3                                                     
      L=IND(J)                                                          
      XB(J,K)=XA(1,I)*V(1,L)+XA(2,I)*V(2,L)+XA(3,I)*V(3,L)              
      XMAX(J)=AMAX1(XMAX(J),XB(J,K))                                    
      XMIN(J)=AMIN1(XMIN(J),XB(J,K))                                    
 1140 CONTINUE                                                          
 1180 CONTINUE                                                          
      NNN = 0                                                           
      N1 = 2                                                            
      N2 = 1                                                            
      IF (115.0/(XMAX(1)-XMIN(1)) .GE. 2.0/0.254) GO TO 1190            
      N1 = 1                                                            
      N2 = 2                                                            
C     CALCULATE SCALE FACTOR TO FILL PAGE OR GIVE 2.5 CMS/A             
 1190 AMAX = AMAX1(XMAX(N2)-XMIN(N2), XMAX(N2+1)-XMIN(N2+1))            
      SCALE = AMIN1(115.0/AMAX, 2.5/0.254)                              
      SCL = 0.254 * SCALE                                               
C     SORT PEAKS IN ORDER OF PLOTTING                                   
 1200 CALL SORT(XB,KUSER1,NUM,N1)                                       
C     OUTPUT HEADING AND PLOT PEAKS                                     
 1210 NNN = NNN + 1                                                     
      WRITE (LT,1220) ITLE,NUMSET,NOFRAG                                
 1220 FORMAT(//1X,119(1H+)//5X,20A4,5X,7HSET NO.,I3,5X,8H CLUSTER,I3)   
      GO TO(1240,1280,1320),NNN                                         
 1240 WRITE(LT,1260)SCL                                                 
 1260 FORMAT(/27X,36HPLOT OF PEAKS ON LEAST SQUARES PLANE,10X,8HSCALE  =
     1,F6.2,7H  CMS/A/////)                                             
      GO TO 1360                                                        
 1280 WRITE(LT,1300)SCL                                                 
 1300 FORMAT(/11X,66HPLOT OF PEAKS ON PLANE ORTHOGONAL TO LEAST AND MOST
     1 SQUARES PLANES,10X,8HSCALE  =,F6.2,7H  CMS/A/////)               
      GO TO 1360                                                        
 1320 WRITE(LT,1340)SCL                                                 
 1340 FORMAT(/27X,35HPLOT OF PEAKS ON MOST SQUARES PLANE,10X,8HSCALE  =,
     1F6.2,7H  CMS/A/////)                                              
 1360 IX=0                                                              
      OFFSET = 0.5 * (115.0 - (XMAX(N2) - XMIN(N2)) * SCALE) + 1.5      
      DO 1460 I=1,NUM                                                   
      IXREL = 0.1 * ALN * SCALE * (XMAX(N1)-XB(N1,I)) - FLOAT(IX) + 0.5 
      IF(IXREL.LE.0)GO TO 1420                                          
      DO 1400 J=1,IXREL                                                 
      WRITE(LT,1380)                                                    
 1380 FORMAT(1X)                                                        
 1400 CONTINUE                                                          
 1420 IX=IX+IXREL                                                       
      IY=SCALE*(XB(N2,I)-XMIN(N2))+OFFSET                               
      DO 1440 J=1,IY                                                    
      IFMT(J+2)=IBLANK                                                  
 1440 CONTINUE                                                          
      IFMT(IY+3)=IEND                                                   
      K=XB(4,I)+0.5                                                     
      WRITE(LT,IFMT)K                                                   
 1460 CONTINUE                                                          
C     TEST FOR PLOTTING OF NEXT PROJECTION                              
      IF (NPROJ .GT. NNN) GO TO 1500                                    
      IF (NPROJ .GT. 0 .OR. NNN .GE. 2) GO TO 1600                      
      NTEMP = 4-NNN                                                     
      IND1 = IND(NTEMP)                                                 
      IND2 = IND(NTEMP-1)                                               
      IF (B(IND2,IND2) .GT. 2.0*B(IND1,IND1)) GO TO 1600                
 1500 IF (NNN .EQ. 2) GO TO 1540                                        
      IF (N1 .EQ. 2) GO TO 1560                                         
      N2 = 3                                                            
      GO TO 1210                                                        
 1540 N2 = 2                                                            
      IF (N1 .EQ. 3) GO TO 1210                                         
 1560 N1 = 3                                                            
      GO TO 1200                                                        
 1600 RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
      SUBROUTINE OUTERP(ISTART,KMATCH,FOMF)                             
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      CHARACTER*4 ICH,IBL,ISK,ICY,LR,LX,LL,JK
      DIMENSION ICH(10), KMATCH(20)                                     
      DATA IBL/' '/,ISK/'*'/,ICY/'Y'/                                   
      DATA ICH/'0','1','2','3','4','5','6','7','8','9'/                 
C     DECIDE IF SET IS WORTH PRINTING                                   
      ISTART=-ISTART                                                    
      FOMM=0.0                                                          
      DO 200 I=1,NAT                                                    
      J=JFRAG(I)                                                        
      IF(J.EQ.0)goto 200
	IF(LFRAG(J).LT.4.OR.KEYST(I).LE.0) GO TO 200            
      FOMM=FOMM+ALOG10(FLOAT(LFRAG(J)))*X(4,I)*FLOAT(IWT)               
  200 CONTINUE                                                          
      IDR=0                                                             
      IF(FOMM.GT.FOMF) IDR=1                                            
      IF(FOM.GE.FOMM.AND.FOM.GE.FOMF) RETURN                            
      FOM=AMAX1(FOMM,FOMF)                                              
      DO 240 I=1,NAT                                                    
      IF(IFRAG(I).NE.NOFRAG) GO TO 240                                  
      IUSE(I)=IABS(IUSE(I))                                             
      IF(JCON(I).LE.0) GO TO 240                                        
      J=JFRAG(I)                                                        
      IF(LFRAG(J).LT.4) GO TO 240                                       
      IF(IDR.EQ.0) IUSE(I)=-1                                           
      IF(IDR.EQ.1.AND.KEYST(I).GT.0) IUSE(I)=-1                         
  240 CONTINUE                                                          
      ISTART=-ISTART                                                    
      WRITE(LT,245)                                                     
  245 FORMAT(//1H ,119(1H-))                                            
C     OUTPUT FRAGMENT COMPARISON RESULTS                                
      IF(MFRN.EQ.0) GO TO 290                                           
      DO 270 K=1,MFRAG                                                  
      IF(LFRAG(K).LT.5) GO TO 270                                       
      NID=0                                                             
      DO 250 I=1,NAT                                                    
      IF(JFRAG(I).NE.K.OR.KEYST(I).LE.0) GO TO 250                      
      NID=NID+1                                                         
      IONP(1,NID)=I                                                     
      IONP(2,NID)=KEYST(I)                                              
  250 CONTINUE                                                          
      IF(NID.GT.0) WRITE(LT,260) NID,K,KMATCH(K),((IONP(I,J),I=1,2),    
     1 J=1,NID)                                                         
  260 FORMAT(/1H0,24X,I5,3X,17HPEAKS OF FRAGMENT,I5,3X,                 
     1 34HMATCH WITH ATOMS OF INPUT MOLECULE,I5/                        
     2 1H0,35X,24HPEAK-ATOM CORRESPONDENCE//(10(I6,2H -,I4)))           
  270 CONTINUE                                                          
C     DETERMINE RING STRUCTURE                                          
  290 DO 300 I=1,NAT                                                    
      IK(I)=JCON(I)                                                     
      IF(JCON(I).GT.0) LAST=I                                           
  300 CONTINUE                                                          
  400 NST=0                                                             
      DO 500 I=1,NAT                                                    
      IF(IK(I).NE.1) GO TO 500                                          
      NST=1                                                             
      IK(I)=0                                                           
      KS=ICON(I)+1                                                      
      KL=ICON(I+1)                                                      
      DO 450 J=KS,KL                                                    
      K=JBOND(J)/8192                                                   
      IF(K.LE.0) GO TO 450                                              
      IF(IK(K).GE.1) IK(K)=IK(K)-1                                      
  450 CONTINUE                                                          
  500 CONTINUE                                                          
      IF(NST.EQ.1) GO TO 400                                            
      WRITE(LT,650) NOFRAG,ISTART                                       
  650 FORMAT(//5X,25HINTERPRETATION OF CLUSTER,I3,27H  STARTING WITH PEA
     1K NUMBER,I3)                                                      
      LMAX=0                                                            
      M=0                                                               
      DO 1500 I=1,NAT                                                   
      IF(JCON(I).LE.0) GO TO 1500                                       
      M=M+1                                                             
      LW(M+30)=I                                                        
      IF(M.EQ.25.OR.I.EQ.LAST) THEN
      WRITE(LT,700) (LW(K+30),K=1,M)
C
C  WRITE FRAGMENT INFORMATION TO UNIT 15
C
      WRITE(15,701) 1
      WRITE(15,701) (LW(K+30),K=1,M)
  701 FORMAT(25I3)               
      ENDIF
  700 FORMAT(/1H0,4HPEAK,8X,25I4)                                       
      K=ICON(I)                                                         
      KL=ICON(I+1)                                                      
      DO 800 J=1,6                                                      
      MX=M+30*(J-1)                                                     
      LR(MX)=IBL                                                        
      LL(MX)=IBL                                                        
      LX(MX)=IBL                                                        
  740 K=K+1                                                             
      IF(K.GT.KL) GO TO 750                                             
      IF(JBOND(K).LE.0) GO TO 740                                       
      LMAX=MAX0(J,LMAX)                                                 
      JBS=JBOND(K)/8192                                                 
      JJ=JBS/100                                                        
      IF(JJ.GT.0) LR(MX)=ICH(JJ+1)                                      
      JJ=JBS/10-JJ*10                                                   
      IF(JBS.GE.10) LL(MX)=ICH(JJ+1)                                    
      JJ=MOD(JBS,10)                                                    
      LX(MX)=ICH(JJ+1)                                                  
  750 IF(LMAX.LT.J) GO TO 800                                           
      MJ=30*(J-1)+1                                                     
      IF(M.EQ.25.OR.I.EQ.LAST) WRITE(LT,770) (LR(L),LL(L),LX(L),L=MJ,MX)
  770 FORMAT(1H ,8HBONDS TO,4X,25(1X,3A1))                              
  800 CONTINUE                                                          
      LW(M)=JFRAG(I)                                                    
      JK(M)=IBL                                                         
      IF(IK(I).GE.2) JK(M)=ISK                                          
      IF(M.EQ.25.OR.I.EQ.LAST) WRITE(LT,840) (JK(K),K=1,M)              
  840 FORMAT(1H ,4HRING,8X,25(3X,A1))                                   
      IF(M.EQ.25.OR.I.EQ.LAST) THEN
      WRITE(LT,850) (LW(K),K=1,M)
C
C  WRITE FRAGMENT INFORMATION TO UNIT 15
C
      WRITE(15,701) 2
      WRITE(15,851) (LW(K),K=1,M)
  851 FORMAT(25I3) 
      ENDIF
  850 FORMAT(1H ,8HFRAGMENT,4X,25I4)                                    
      IF(MFRN.LE.0) GO TO 1490                                          
      JK(M+30)=IBL                                                      
      IF(KEYST(I).GT.0) JK(M+30)=ICY                                    
      IF(M.EQ.25.OR.I.EQ.LAST) WRITE(LT,860) (JK(K+30),K=1,M)           
  860 FORMAT(1H ,7HMATCHED,5X,25(3X,A1))                                
 1490 IF(M.NE.25) GO TO 1500                                            
      M=0                                                               
      LMAX=1                                                            
 1500 CONTINUE                                                          
      WRITE (LT,1580) (LFRAG(I),I=1,MFRAG)                              
C
C  WRITE FRAGMENT INFORMATION TO UNIT 15
C
      WRITE(15,701) 3
      WRITE (15,1581) (LFRAG(I),I=1,MFRAG)                              
C  FORMAT was 12I3
 1581 FORMAT(25I3)
 1580 FORMAT(/4X,33H    NO. OF PEAKS IN EACH FRAGMENT,5X,12I4)          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     CALCULATE AND OUTPUT PEAK POSITIONS,BOND LENGTHS,AND ANGLES.      
      SUBROUTINE BONGLE                                                 
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON /ATOMS/ X(4,2000)
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      COMMON/CENT/ TL(3,4),TS(3,24),FS(3,3,24),MLAT,NEQV                
      COMMON /SIZE/ KFRAG(200),NFRAG,LFRAG(200),MFRAG,NOFRAG,NN,MFRN      
      DIMENSION   IB(3), XS(3), X1(3), X2(3), JFMT(20), ENIL1(4,4),     
     1 LINE(30), LINE1(4,6), ENIL(30), JBND(30), XSTOR(3)               
      CHARACTER*4 JFMT,IBLANK,IEND
      DATA JFMT(1)/'( 1X'/,  JFMT(2)/',I6,'/, JFMT(3)/'I13,'/,          
     1 JFMT(4)/' 7X,'/,  JFMT(5)/'3F10'/, JFMT(6)/'.4, '/,              
     2 IBLANK/'4X, '/, IEND/'I4) '/                                     
C     OUTPUT PEAK HEIGHTS, PEAK COORDINATES AND CLUSTER NUMBERS         
      WRITE (LT,900) ITLE                                               
  900 FORMAT(//1X,119(1H+)//1X,20A4,22X,17HPEAK  COORDINATES///         
     1     1X,7H   PEAK,7X,6HHEIGHT,13X,1HX,9X,1HY,9X,1HZ,9X,           
     2     15H CLUSTER NUMBER/)                                         
      DO 940 I=1,NAT                                                    
      ICON(I+1)=0                                                       
      IFRAG(I)=IABS(IFRAG(I))                                           
C  Maximum was 15; reset to 10!!!  
      N=MIN0(IFRAG(I)+1,10)                                             
      DO 920 J=1,N                                                      
      JFMT(J+6)=IBLANK                                                  
  920 CONTINUE                                                          
      JFMT(N+7)=IEND                                                    
      K=X(4,I)+0.5                                                      
      WRITE(LT,JFMT)I,K,(X(J,I),J=1,3),IFRAG(I)                         
  940 CONTINUE                                                          
      N = MIN0(NFRAG, 14)                                               
      WRITE (LT,960) (KFRAG(I),I=1,N)                                   
      IW=0                                                              
  960 FORMAT(/19X,38HTOTAL NUMBER OF PEAKS IN EACH CLUSTER ,8X,14I4)    
      WRITE(LT,1110) ITLE                                               
 1110 FORMAT(//1X,119(1H+)//1X,20A4,11X,                                
     1  28HTABLE OF INTERPEAK DISTANCES//1H ,2X,4HFROM,3X,7HTO DIST)    
      ICON(1)=0                                                         
      DO 1115 I=1,MCON                                                  
      II=IBOND(I)/4194304                                               
      ICON(II+1)=I                                                      
 1115 CONTINUE                                                          
      DO 1260 I=1,NAT                                                   
      IF(ICON(I+1).EQ.0) ICON(I+1)=ICON(I)                              
      N=0                                                               
      JUMP=0                                                            
      DO 1220 J=1,NAT                                                   
      IF(J.EQ.I) GO TO 1170                                             
      DO 1120 K=1,3                                                     
      X1(K)=X(K,I)-X(K,J)                                               
      IF(ABS(X1(K)).GT.DXMAX(K)) GO TO 1170                             
 1120 CONTINUE                                                          
      DIST=QUAD(X1,X1,T)                                                
      IF(DIST.GT.DMUT) GO TO 1170                                       
      N=N+1                                                             
      JBND(N)=J                                                         
      ENIL(N)=SQRT(DIST)                                                
 1170 IF(N.LT.10.AND.J.NE.NAT) GO TO 1220                               
      IF(JUMP.EQ.0.AND.N.GT.0) WRITE(LT,1190) I,(JBND(L),ENIL(L),L=1,N) 
 1190 FORMAT(1H ,I5,10(I6,F5.2))                                        
      IF(JUMP.NE.0.AND.N.GT.0) WRITE(LT,1210) (JBND(L),ENIL(L),L=1,N)   
 1210 FORMAT(1H ,5X,10(I6,F5.2))                                        
      N=0                                                               
      JUMP=1                                                            
 1220 CONTINUE                                                          
 1260 CONTINUE                                                          
      DMX=SQRT(DMAX)                                                    
      WRITE(LT,1300) DMX                                                
 1300 FORMAT( ///16X,81HTABLE OF BOND ANGLES (IN DEGREES) AMONG PEAKS IN
     1 ABOVE TABLE CLOSER TOGETHER THAN,F5.2,1HA/)                      
      N=0                                                               
      RTOD=1.0/DTOR                                                     
      DO 1500 I=1,NAT                                                   
      KS=ICON(I)+1                                                      
      KL=ICON(I+1)                                                      
      IF(KS.GE.KL) GO TO 1500                                           
      KLM1=KL-1                                                         
      DO 1490 J=KS,KLM1                                                 
      V1=0.001*FLOAT(MOD(IBOND(J),8192))                                
      IF(V1.GT.DMX.OR.V1.LT.0.2) GO TO 1490                             
      JJ=IBOND(J)/8192                                                  
      JJ=MOD(JJ,512)                                                    
      JP1=J+1                                                           
      DO 1480 K=JP1,KL                                                  
      V2=0.001*FLOAT(MOD(IBOND(K),8192))                                
      IF(V2.GT.DMX.OR.V2.LT.0.2) GO TO 1480                             
      KK=IBOND(K)/8192                                                  
      KK=MOD(KK,512)                                                    
      DO 1430 L=1,3                                                     
      X1(L)=X(L,KK)-X(L,JJ)                                             
 1430 CONTINUE                                                          
      DIST=QUAD(X1,X1,T)                                                
      IF(DIST.LT.0.2) GO TO 1480                                        
      COSA=0.5*(V1*V1+V2*V2-DIST)/(V1*V2)                               
      SINA=SQRT(AMAX1(1.0-COSA*COSA,0.001))                             
      N=N+1                                                             
      LINE1(1,N)=JJ                                                     
      LINE1(2,N)=I                                                      
      LINE1(3,N)=KK                                                     
      LINE1(4,N)=AMOD(ATAN2(SINA,COSA)*RTOD+180.0,180.0)+0.5            
      IF(N.LT.6) GO TO 1480                                             
      WRITE(LT,1470) ((LINE1(L,N),L=1,4),N=1,6)                         
 1470 FORMAT(6(I6,2H -,I3,2H -,I3,I4))                                  
      N=0                                                               
 1480 CONTINUE                                                          
 1490 CONTINUE                                                          
 1500 CONTINUE                                                          
      IF(N.NE.0) WRITE(LT,1470) ((LINE1(L,J),L=1,4),J=1,N)              
      N = -1                                                            
      NATM1=NAT-1                                                       
      DO 1800 I=1,NATM1                                                 
      DO 1780 J=I,NAT                                                   
      DO 1740 K=1,NSYM                                                  
      IF(I.EQ.J.AND.K.EQ.1) GO TO 1740                                  
      IF(JSYMM(I,J,K,IB,XS,X1).NE.0) GO TO 1740                         
      IBJ=100*IB(1)+10*IB(2)+IB(3)                                      
      IF(IBJ.EQ.555.AND.K.EQ.1) GO TO 1740                              
      DIST=QUAD(X1,X1,T)                                                
      IF(DIST.GT.DMUT) GO TO 1740                                       
      IF(DIST.LT.0.2.AND.I.EQ.J) ICON(I)=10000                          
      ISIM=MOD(K,NEQV)                                                  
      IF(ISIM.EQ.0) ISIM=NEQV                                           
      IP=(K-1)/NEQV                                                     
      ILAT=MOD(IP,MLAT)+1                                               
      IF(IP.GE.MLAT) ISIM=-ISIM                                         
      N=N+1                                                             
      IF (N.EQ.0) WRITE(LT,1550)                                        
 1550 FORMAT(//33X,53HDISTANCES BETWEEN ATOMS IN DIFFERENT ASYMMETRIC UN
     1ITS//3(5X,35HFROM   TO SYMM  X    Y    Z    DIST))                
      IF (N.EQ.0) N = 1                                                 
      LINE1(N,1)=I                                                      
      LINE1(N,2)=J                                                      
      LINE1(N,3)=ISIM                                                   
      ENIL1(N,1)=FLOAT(IB(1))+TL(1,ILAT)-5.0                            
      ENIL1(N,2)=FLOAT(IB(2))+TL(2,ILAT)-5.0                            
      ENIL1(N,3)=FLOAT(IB(3))+TL(3,ILAT)-5.0                            
      ENIL1(N,4)=SQRT(DIST)                                             
      IF(N.LT.3) GO TO 1740                                             
      WRITE(LT,1710) ((LINE1(N,L),L=1,3),(ENIL1(N,L),L=1,4),N=1,3)      
 1710 FORMAT(3(I9,I5,1H(,I3,3F5.2,1H),F6.2))                            
      N=0                                                               
 1740 CONTINUE                                                          
 1780 CONTINUE                                                          
 1800 CONTINUE                                                          
      IF(N.GT.0) WRITE(LT,1710) ((LINE1(J,L),L=1,3),                    
     1  (ENIL1(J,L),L=1,4),J=1,N)                                       
      DO 1850 I=1,NAT                                                   
      IF(ICON(I).GT.999) WRITE(LT,1840) I                               
 1840 FORMAT(/5H PEAK,I4,28H  LIES ON A SYMMETRY ELEMENT/)              
 1850 CONTINUE                                                          
      IF(NN.LE.0) GO TO 1900                                            
      IF(NN.GT.1) CALL ISORT(ISYM,NN)                                   
      ISYM(NN+1)=0                                                      
      JJ=0                                                              
      K=0                                                               
      DO 1890 I=1,NN                                                    
      II=ISYM(I)/250000                                                 
      IF(II.NE.JJ) WRITE(LT,1860) II                                    
 1860 FORMAT(/9H  CLUSTER,I3,42H  JOINS TO ITSELF THROUGH THE PEAK PAIR(
     1S))                                                               
      JJ=II                                                             
      K=K+2                                                             
      LW(K-1)=MOD(ISYM(I),250000)/500                                   
      LW(K)=MOD(ISYM(I),500)                                            
      IF(K.LT.12.AND.II.EQ.ISYM(I+1)/250000) GO TO 1890                 
      WRITE(LT,1870) (LW(J),J=1,K)                                      
 1870 FORMAT(1H+,53X,6(I7,1H,,I3)/)                                     
      K=0                                                               
 1890 CONTINUE                                                          
 1900 RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     RETRIEVE CENTRING TRANSLATIONS                                    
      SUBROUTINE CENTRE(J,L)                                            
      COMMON /CENT/ TL(3,4),TS(72),FS(216),MLAT,NEQV                    
      DIMENSION TST(21)                                                 
      DATA TST/0.,0.,0., 0.,0.5,0.5, 0.5,0.,0.5, 0.5,0.5,0., 0.5,0.5,0.5
     1 , 0.333333,0.666667,0.666667, 0.666667,0.333333,0.333333/        
      MLAT=J                                                            
      M=3*L-2                                                           
      TL(1,J)=TST(M)                                                    
      TL(2,J)=TST(M+1)                                                  
      TL(3,J)=TST(M+2)                                                  
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
      SUBROUTINE RDSECT(NR3D,MAX,NNXP2,NNZ,NXZ3,KUSER2)                 
      COMMON /CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,     
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      DIMENSION  NR3D(KUSER2)                                           
      IF (MAX .GE. NXZ3) MAX = 0                                        
      MX = MAX                                                          
      MAX = MAX - 2                                                     
      DO 1320 IZ=1,NNZ                                                  
      MIN = MAX + 3                                                     
      MAX = MAX + NNXP2                                                 
      READ (LIN) (NR3D(IX),IX=MIN,MAX)                                  
      NR3D(MAX+1) = NR3D(MIN)                                           
      NR3D(MAX+2) = NR3D(MIN+1)                                         
 1320 CONTINUE                                                          
      MIN = MAX + 3                                                     
      MAX = MAX + NNXP2 + NNXP2 + 2                                     
      DO 1340 IX=MIN,MAX                                                
      MX = MX + 1                                                       
      NR3D(IX) = NR3D(MX)                                               
 1340 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     COMPUTE EIGENVECTORS AND EIGENVALUES OF REAL SYMMETRIC MATRIX     
      SUBROUTINE EIGEN(B,V,IND)                                         
      DIMENSION B(3,3),V(3,3),IND(3)                                    
      DO 1020 I=1,3                                                     
      DO 1000 J=1,3                                                     
      V(I,J)=0.0                                                        
 1000 CONTINUE                                                          
      V(I,I)=1.0                                                        
 1020 CONTINUE                                                          
 1040 KNT=0                                                             
      IND1=1                                                            
      IND3=1                                                            
      DO 1500 I=1,2                                                     
      IP1=I+1                                                           
      DO 1460 J=IP1,3                                                   
      IF (ABS(B(I,J)) .LT. 0.000001 * B(IND1,IND1)) KNT = KNT + 1       
      BIJ=B(I,I)-B(J,J)                                                 
      IF(ABS(B(I,J)).LT.ABS(BIJ))GO TO 1100                             
      T=SIGN(1.0,B(I,J)*BIJ)                                            
      GO TO 1180                                                        
 1100 T=B(I,J)/BIJ                                                      
 1180 G=T/(2.0+2.0*T*T)                                                 
      SN=2.0*G/(1.0+G*G)                                                
      CS=1.0-G*SN                                                       
      DO 1200 K=1,3                                                     
      BIK=B(I,K)                                                        
      B(I,K)=CS*B(I,K)+SN*B(J,K)                                        
      B(J,K)=CS*B(J,K)-SN*BIK                                           
 1200 CONTINUE                                                          
      DO 1220 K=1,3                                                     
      BKI=B(K,I)                                                        
      B(K,I)=CS*B(K,I)+SN*B(K,J)                                        
      B(K,J)=CS*B(K,J)-SN*BKI                                           
      VKI=V(K,I)                                                        
      V(K,I)=CS*V(K,I)+SN*V(K,J)                                        
      V(K,J)=CS*V(K,J)-SN*VKI                                           
 1220 CONTINUE                                                          
 1460 CONTINUE                                                          
      IF(B(IP1,IP1).GT.B(IND1,IND1))IND1=IP1                            
      IF(B(IND3,IND3).GT.B(IP1,IP1))IND3=IP1                            
 1500 CONTINUE                                                          
      IF(KNT.LT.3)GO TO 1040                                            
      IND(1)=IND1                                                       
      IND(2)=1                                                          
      IND(3)=IND3                                                       
      IF(IND1.EQ.IND(2).OR.IND3.EQ.IND(2))IND(2)=2                      
      IF(IND1.EQ.IND(2).OR.IND3.EQ.IND(2))IND(2)=3                      
C     CHECK FOR RIGHT-HANDED SET OF VECTORS                             
      DET = V(1,1)*(V(2,2)*V(3,3)-V(2,3)*V(3,2))+V(1,2)*(V(2,3)*V(3,1)  
     1  -V(2,1)*V(3,3))+V(1,3)*(V(2,1)*V(3,2)-V(2,2)*V(3,1))            
      IF (DET .GT. 0.0) RETURN                                          
      DO 1520 I=1,3                                                     
      V(I,3) = -V(I,3)                                                  
 1520 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     SORT PEAKS IN ORDER OF PEAK HEIGHT OR IN ORDER OF PLOTTING        
      SUBROUTINE SORT(X,KUSER1,NAT,N)                                   
      DIMENSION X(4,KUSER1),T(4)                                        
      INT=2                                                             
 1000 INT=INT+INT                                                       
      IF(INT.LT.NAT)GO TO 1000                                          
      INT=MIN0(NAT,(3*INT)/4-1)                                         
 1020 INT=INT/2                                                         
      IFIN=NAT-INT                                                      
      DO 1200 II=1,IFIN                                                 
      I=II                                                              
      J=I+INT                                                           
      IF(X(N,I).GE.X(N,J))GO TO 1200                                    
      DO 1060 K=1,4                                                     
      T(K)=X(K,J)                                                       
 1060 CONTINUE                                                          
 1080 DO 1100 K=1,4                                                     
      X(K,J)=X(K,I)                                                     
 1100 CONTINUE                                                          
      J=I                                                               
      I=I-INT                                                           
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120                                               
      IF(X(N,I).LT.T(N))GO TO 1080                                      
 1140 DO 1160 K=1,4                                                     
      X(K,J)=T(K)                                                       
 1160 CONTINUE                                                          
 1200 CONTINUE                                                          
      IF(INT.NE.1)GO TO 1020                                            
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     GENERAL INTEGER SORT ROUTINE                                      
      SUBROUTINE ISORT(N,M)                                             
      DIMENSION N(M)                                                    
      INT=2                                                             
 1000 INT=INT+INT                                                       
      IF(INT.LT.M) GO TO 1000                                           
      INT=MIN0(M,(3*INT)/4-1)                                           
 1020 INT=INT/2                                                         
      IFIN=M-INT                                                        
      DO 1200 II=1,IFIN                                                 
      I=II                                                              
      J=I+INT                                                           
      IF(N(I).LE.N(J)) GO TO 1200                                       
      IT=N(J)                                                           
 1080 N(J)=N(I)                                                         
      J=I                                                               
      I=I-INT                                                           
      IF(I.LE.0)GOTO 1140
C     if(I)1140,1140,1120
      IF(N(I).GT.IT) GO TO 1080                              
 1140 N(J)=IT                                                           
 1200 CONTINUE                                                          
      IF(INT.NE.1) GO TO 1020                                           
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     ELIMINATE THE IITH PEAK AND UPDATE THE BONDING ARRAY              
      SUBROUTINE ELIM(II,NNN,JCN,JBND,ICN,KUSER1)                       
      DIMENSION JCN(KUSER1), ICN(KUSER1), JBND(2000)                    
      JCN(II)=0                                                         
      NNN=0                                                             
      KS=ICN(II)+1                                                      
      KL=ICN(II+1)                                                      
      IF(KS.GT.KL) RETURN                                               
      DO 20 I=KS,KL                                                     
      J=JBND(I)/8192                                                    
	IF(J.GE.1)THEN
      JCN(J)=JCN(J)-1                                                   
      JBND(I)=0                                                         
      KB=ICN(J)+1                                                       
      KE=ICN(J+1)                                                       
      IF(KB.GT.KE) GO TO 20                                             
      DO 10 K=KB,KE                                                     
      L=JBND(K)/8192                                                    
      IF(L.EQ.II) JBND(K)=0                                             
   10 CONTINUE                                                          
   	ENDIF
   20 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     FUNCTION USED IN THE CALCULATION OF DISTANCES AND ANGLES          
      FUNCTION QUAD(X1,X2,T)                                            
      DIMENSION X1(3),X2(3),T(3,3)                                      
      QUAD=0.0                                                          
      DO 1000 I=1,3                                                     
      QUAD = QUAD+X2(I)*(T(I,1)*X1(1)+T(I,2)*X1(2)+T(I,3)*X1(3))        
 1000 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     PERFORM THE KTH SYMMETRY OPERATION ON THE JTH PEAK                
C     AND MOVE IT AS CLOSE AS POSSIBLE TO PEAK I BY LATTICE TRANSLATIONS
      FUNCTION JSYMM(I,J,K,IB,XS,X1)                                    
      COMMON /ATOMS/ X(4,2000)                                           
      COMMON/MISC/ITLE(20),CELL(6),T(3,3),DXMAX(3),MCON,IWT,FOM         
      DIMENSION IB(3),XS(3),X1(3)                                       
      JSYMM = 0                                                         
      CALL OPER(K,XS,X(1,J),X(2,J),X(3,J))                              
      DO 1080 L=1,3                                                     
      IB(L)=5                                                           
 1060 X1(L)=X(L,I)-XS(L)                                                
      IF(ABS(X1(L)).LE.0.5)GO TO 1070                                   
      XS(L)=XS(L)+SIGN(1.0,X1(L))                                       
      IB(L)=IB(L)+ISIGN(1,IFIX(2.0*X1(L)))                              
      GO TO 1060                                                        
 1070 IF (ABS(X1(L)) .GT. DXMAX(L)) GO TO 1100                          
 1080 CONTINUE                                                          
      RETURN                                                            
 1100 JSYMM = 1                                                         
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     APPLY J'TH SYMMETRY ELEMENT TO X,Y,Z & PUT RESULT IN XN           
      SUBROUTINE OPER(J,XN,X,Y,Z)                                       
      DIMENSION XN(3)                                                   
      COMMON /CENT/ TL(12),TS(72),FS(216),MLAT,NEQV                     
      ISYM=MOD(J,NEQV)                                                  
      IF(ISYM.EQ.0) ISYM=NEQV                                           
      IP=(J-1)/NEQV                                                     
      ILAT=3*MOD(IP,MLAT)                                               
      JT=3*(ISYM-1)                                                     
      JJ=9*ISYM-8                                                       
      DO 20 L=1,3                                                       
      IND1=JT+L                                                         
      IND2=ILAT+L                                                       
      XN(L)=X*FS(JJ)+Y*FS(JJ+1)+Z*FS(JJ+2)                              
      IF(IP.GE.MLAT) XN(L)=-XN(L)                                       
      XN(L)=XN(L)+TS(IND1)+TL(IND2)                                     
      JJ=JJ+3                                                           
   20 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     POINT BY POINT FRAGMENT COMPARISON                                
      SUBROUTINE TELL(N,NR,M,MR,MERIT,KOMP,INA,INP,LLW)                 
      DIMENSION JNP(2000),JNA(2000),LMP(2000),LMA(2000)                     
      DIMENSION INA(6,2000),INP(6,2000),LLW(2000)                          
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),KAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      COMMON/CONST/ LC, LT, LIN, NOUT, DTOR, ANGMIN, ANGMAX, DMIN,      
     1  DMAX,DMUT,DM,DFRG,ALN,NSYM,NUMSET,NATM,NAT,NPIC,METAL           
      ICOUNT=0                                                          
      NAX=MAX0(N,M)                                                     
      DO 20 I=1,NAX                                                     
      KEY(I)=0                                                          
      IPL(I)=0                                                          
      MO(I)=0                                                           
   20 CONTINUE                                                          
      KY=MAX0(NR,6)                                                     
      LY=MAX0(MR,6)                                                     
      L=1                                                               
      LMP(1)=0                                                          
      LMA(1)=0                                                          
      DO 50 I=1,NAX                                                     
      LMP(I+1)=LMP(I)                                                   
      LMA(I+1)=LMA(I)                                                   
      DO 40 J=1,6                                                       
      IF(INA(J,I).GT.I.OR.INA(J,I).EQ.0) GO TO 30                       
      K=LMA(I+1)+1                                                      
      JNA(K)=INA(J,I)                                                   
      LMA(I+1)=K                                                        
   30 IF(INP(J,I).EQ.0) GO TO 40                                        
      K=LMP(I+1)+1                                                      
      JNP(K)=INP(J,I)                                                   
      LMP(I+1)=K                                                        
   40 CONTINUE                                                          
   50 CONTINUE                                                          
      NF=0                                                              
      LR(M+1)=0                                                         
      DO 90 I=1,M                                                       
      MM=M+1-I                                                          
      LR(MM)=LR(MM+1)+LLW(MM)                                           
   90 CONTINUE                                                          
  100 IK(L)=LMA(L)                                                      
      IF(L.LE.M) GO TO 200                                              
  150 L=L-1                                                             
      IF(L.EQ.0) GO TO 500                                              
      IF(KEY(L).EQ.0) GO TO 150                                         
      KX=KEY(L)                                                         
      NF=NF-LLW(L)                                                      
      IPL(KX)=0                                                         
      IF(MERIT.GT.LR(1)) GO TO 150                                      
  200 IF(NF.NE.0) GO TO 230                                             
      K=KEY(L)+1                                                        
      IF(K.LE.N) GO TO 350                                              
  220 KEY(L)=0                                                          
      L=L+1                                                             
      IF(NF+LR(L).GE.MERIT) GO TO 100                                   
      GO TO 150                                                         
  230 IF(IK(L).NE.LMA(L).AND.JK(L).NE.KAN(L)) GO TO 260                 
  240 IK(L)=IK(L)+1                                                     
      IF(IK(L).GT.LMA(L+1)) GO TO 220                                   
      K=IK(L)                                                           
      K=JNA(K)                                                          
      IF(KEY(K).EQ.0) GO TO 240                                         
      K=KEY(K)                                                          
      JK(L)=LMP(K)                                                      
      KAN(L)=LMP(K+1)                                                   
  260 JK(L)=JK(L)+1                                                     
      K=JK(L)                                                           
      K=JNP(K)                                                          
      IF(IPL(K).NE.0) GO TO 230                                         
      LP=LMP(K+1)                                                       
      LA=LMA(L+1)                                                       
      IF(L.GT.LY) GO TO 290                                             
      LJ=LMA(L)                                                         
  270 LJ=LJ+1                                                           
      IF(LJ.GT.LA) GO TO 290                                            
      J=JNA(LJ)                                                         
      IF(KEY(J).EQ.0) GO TO 270                                         
      LB=LMP(K)+1                                                       
  280 IF(LB.GT.LP) GO TO 230                                            
      IF(JNP(LB).EQ.KEY(J)) GO TO 270                                   
      LB=LB+1                                                           
      GO TO 280                                                         
  290 IF(K.GT.KY) GO TO 350                                             
      LJ=LMP(K)                                                         
  300 LJ=LJ+1                                                           
      IF(LJ.GT.LP) GO TO 350                                            
      J=JNP(LJ)                                                         
      IF(IPL(J).EQ.0) GO TO 300                                         
      LB=LMA(L)+1                                                       
  310 IF(LB.GT.LA) GO TO 230                                            
      IF(JNA(LB).EQ.IPL(J)) GO TO 300                                   
      LB=LB+1                                                           
      GO TO 310                                                         
  350 KEY(L)=K                                                          
      IPL(K)=L                                                          
      NF=NF+LLW(L)                                                      
      ICOUNT=ICOUNT+1                                                   
      IF(NF.LT.MERIT) GO TO 400                                         
      MERIT=NF+1                                                        
      DO 380 I=1,NAX                                                    
      IF(KOMP.EQ.1) MO(I)=KEY(I)                                        
      IF(KOMP.EQ.2) MO(I)=IPL(I)                                        
  380 CONTINUE                                                          
  400 L=L+1                                                             
      IF(ICOUNT.LT.100000) GO TO 100                                    
      WRITE(LT,450)                                                     
  450 FORMAT(1H0,30X,57HWARNING - FRAGMENT COMPARISON TOO COMPLICATED FO
     1R PROGRAM)                                                        
  500 RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
C     CANONICAL DESCRIPTION & SORT FOR FRAGMENT COMPARISON              
      SUBROUTINE CANON(M,MR)                                            
      COMMON ISYM(100),INBOND(1000),IFRAG(2000),ICON(2000), 
     1 IBOND(2000),JFRAG(2000),JCON(2000),JBOND(2000),IUSE(2000),
     2 IONA(6,2000),IONP(6,2000),MO(2000),MU(2000),NO(2000),NU(2000),
     3 KEYST(2000),LW(2000),LR(2000),LX(2000),JK(2000),IK(2000),
     4 KEY(2000),IPL(2000),CAN(2000),CON(2000),LL(2000),IA(6,2000),
     5 LS(2000),DUM(14400)
      DO 20 I=1,M                                                       
      CON(I)=1.0                                                        
      CAN(I)=0.0                                                        
      LL(I)=0                                                           
      NU(I)=0                                                           
      DO 10 J=1,6                                                       
      IF(IONP(J,I).GT.0) LL(I)=LL(I)+1                                  
   10 CONTINUE                                                          
   20 CONTINUE                                                          
      AM=0.0                                                            
      DO 110 I=1,M                                                      
      DO 80 J=1,M                                                       
      DO 70 K=1,6                                                       
      L=IONP(K,J)                                                       
      IF(L.GT.0) CAN(J)=CAN(J)+CON(L)                                   
   70 CONTINUE                                                          
   80 CONTINUE                                                          
      DO 90 J=1,M                                                       
      CON(J)=CAN(J)                                                     
      CAN(J)=0.0                                                        
      IF(I.EQ.M) AM=AMAX1(AM,CON(J))                                    
   90 CONTINUE                                                          
  110 CONTINUE                                                          
      DO 130 I=1,M                                                      
      A=CON(I)/AM                                                       
      A=10000.0*A*A                                                     
      LX(I)=A+20000.5                                                   
      IF(LX(I).EQ.20000) LX(I)=20001                                    
  130 CONTINUE                                                          
      DO 255 IEN=1,10                                                   
      DO 250 I=1,M                                                      
      IF(LL(I).NE.1) GO TO 250                                          
      DO 240 K=1,M                                                      
      IF(LL(K).LE.1) GO TO 240                                          
      DO 230 J=1,6                                                      
      IF(IONP(J,K).EQ.I) LL(K)=LL(K)-1                                  
  230 CONTINUE                                                          
  240 CONTINUE                                                          
      LL(I)=0                                                           
      LX(I)=LX(I)-20000                                                 
  250 CONTINUE                                                          
  255 CONTINUE                                                          
      DO 300 I=1,M                                                      
      LM=0                                                              
      DO 280 J=1,M                                                      
      IF(LX(J).LE.LM) GO TO 280                                         
      IF(I.EQ.1) GO TO 270                                              
      DO 260 K=1,6                                                      
      L=IONP(K,J)                                                       
      IF(L.EQ.0) GO TO 280                                              
      IF(NU(L).NE.0) GO TO 270                                          
  260 CONTINUE                                                          
      GO TO 280                                                         
  270 LM=LX(J)                                                          
      IX=J                                                              
  280 CONTINUE                                                          
      NU(IX)=I                                                          
      DO 290 J=1,6                                                      
      IA(J,I)=IONP(J,IX)                                                
  290 CONTINUE                                                          
      LS(I)=LX(IX)                                                      
      LX(IX)=0                                                          
  300 CONTINUE                                                          
      MR=0                                                              
      DO 350 I=1,M                                                      
      LX(I)=LS(I)                                                       
      IF(LL(I).GT.1) MR=MR+1                                            
      DO 330 J=1,6                                                      
      IONP(J,I)=0                                                       
      IF(IA(J,I).EQ.0) GO TO 330                                        
      MIN=1000                                                          
      DO 320 K=1,6                                                      
      IF(IA(K,I).LE.0) GO TO 320                                        
      IX=IA(K,I)                                                        
      IF(MIN.LT.NU(IX)) GO TO 320                                       
      MIN=NU(IX)                                                        
      KM=K                                                              
  320 CONTINUE                                                          
      IONP(J,I)=MIN                                                     
      IA(KM,I)=-1                                                       
  330 CONTINUE                                                          
  350 CONTINUE                                                          
      RETURN                                                            
      END                                                               

